unit CallPickUpDlg;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,

  VaxTeleServerSIP, Vcl.ExtCtrls, Vcl.StdCtrls;


type
  TCallPickUpForm = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    CombopickupGroup: TComboBox;
    Label2: TLabel;
    comboLogin: TComboBox;
    listLogin: TListBox;
    BTN_ADD_MEMBER: TButton;
    BTN_REMOVE_MEMBER: TButton;
    BTN_CLEAR_MEMBER: TButton;
    BTN_ADD: TButton;
    BTN_REMOVE: TButton;
    BTN_CLEAR: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure BTN_ADDClick(Sender: TObject);
    procedure BTN_REMOVEClick(Sender: TObject);
    procedure BTN_ADD_MEMBERClick(Sender: TObject);
    procedure BTN_REMOVE_MEMBERClick(Sender: TObject);
    procedure BTN_CLEAR_MEMBERClick(Sender: TObject);
    procedure CombopickupGroupChange(Sender: TObject);
    procedure BTN_CLEARClick(Sender: TObject);

  private

    function AddPickUpGroupChecks(): boolean;

    procedure FillLogin();
    procedure FillPickUpGroup();

    procedure ClearDlgContent();
    procedure UpdateDlgContent();
  public

    procedure OnSetActive();
    constructor Create(AOwner : TComponent; var pVaxTeleSIP : TVaxTeleServerSIP); reintroduce; overload;
  end;

var
  CallPickUpForm: TCallPickUpForm;
  m_pVaxTeleSIP : TVaxTeleServerSIP;

implementation

{$R *.dfm}


function TCallPickUpForm.AddPickUpGroupChecks(): boolean;
begin

  if(CombopickupGroup.Text = '') then
  begin
    ShowMessage('Please enter PickUp Group Name.');
    Exit();
  end;

  Result := True;

end;

procedure TCallPickUpForm.FillLogin();
var
  objLoginList : TStringList;
  sAgentName : string;

begin

  objLoginList := TStringList.Create();
  m_pVaxTeleSIP.GetUserAll(objLoginList);

  for sAgentName in objLoginList do
    begin
      comboLogin.Items.Add(sAgentName);
    end;

    ComboLogin.ItemIndex := 0;
end;

procedure TCallPickUpForm.FillPickUpGroup();
var
  objPickUpList : TStringList;
  sQueueName : string;

begin

  objPickUpList := TStringList.Create();
  m_pVaxTeleSIP.GetPickGroupList(objPickUpList);

  for sQueueName in objPickUpList do
    begin
      CombopickupGroup.Items.Add(sQueueName);
    end;

    CombopickupGroup.ItemIndex := 0;
end;

procedure TCallPickUpForm.BTN_ADDClick(Sender: TObject);

    var sPickUpMember : string;
    var sPcikUpName : string;

begin

  if(CombopickupGroup.Text = '') then
  begin
    ShowMessage('Fill Group Name Field first.');
    Exit();
  end;

	m_pVaxTeleSIP.RemoveCallPickUpGroup(CombopickupGroup.Text);

	 if(m_pVaxTeleSIP.AddCallPickUpGroup(CombopickupGroup.Text) <> true) then
    begin
         ShowMessage('CallPickGroup Not Added Successfully.');
    Exit();
    end;

  for sPickUpMember in listLogin.Items do
  begin
         m_pVaxTeleSIP.AddCallPickUpGroupMember(CombopickupGroup.Text, sPickUpMember);
  end;

  CombopickupGroup.Items.Add(CombopickupGroup.Text);
  ShowMessage('PickUp Group created successfully"');

end;

procedure TCallPickUpForm.BTN_ADD_MEMBERClick(Sender: TObject);
begin
      listLogin.Items.Add(comboLogin.Text);
end;


procedure TCallPickUpForm.BTN_CLEARClick(Sender: TObject);
begin
     CombopickupGroup.Text := '';
     listLogin.Clear();

end;

procedure TCallPickUpForm.BTN_CLEAR_MEMBERClick(Sender: TObject);
begin
      listLogin.Clear();
end;

procedure TCallPickUpForm.BTN_REMOVEClick(Sender: TObject);
begin
       m_pVaxTeleSIP.RemoveCallPickUpGroup(CombopickupGroup.Text);

       listLogin.Clear();
       CombopickupGroup.Items.Delete(CombopickupGroup.Items.IndexOf(CombopickupGroup.Text));
end;

procedure TCallPickUpForm.UpdateDlgContent();
begin

   FillPickUpGroup();
   FillLogin();

end;

procedure TCallPickUpForm.ClearDlgContent();
begin

   CombopickupGroup.Text := '';
   listLogin.Clear();

end;

procedure TCallPickUpForm.BTN_REMOVE_MEMBERClick(Sender: TObject);
var
nIndex: Integer;
sAgentName  : string;
begin

    for nIndex:= listLogin.items.count -1 downto 0 do
      if listLogin.selected[nIndex] then
        listLogin.items.delete(nIndex);
end;

procedure TCallPickUpForm.CombopickupGroupChange(Sender: TObject);
var
   objMemberList : TStringList;
   sAgentName : string;

begin
       objMemberList := TStringList.Create();
        m_pVaxTeleSIP.GetPickUpGroupAgentList(CombopickupGroup.Text, objMemberList);

        if(objMemberList.Count > 0) Then
           listLogin.Clear();

        for sAgentName in objMemberList do
        begin
         listLogin.Items.Add(sAgentName);
        end;
end;


procedure TCallPickUpForm.OnSetActive();
begin
    FillPickUpGroup();
    FillLogin();
end;

constructor TCallPickUpForm.create(AOwner : TComponent; var pVaxTeleSIP : TVaxTeleServerSIP);
begin
        inherited Create(AOwner);
        m_pVaxTeleSIP := pVaxTeleSIP;
end;

end.
