﻿
Imports System.Text

Public Class cVaxServerSIP : Inherits cVaxServerExCOM

    Public m_objErrorLogDlg As ErrorLogForm
    Public m_objStatusLogDlg As StatusLogForm

    Private m_objSettingDefault As cVaxSettingDefault

    Const HOLD_MUSIC_FILE = "Hold.wav"
    Const DIAL_TONE_MUSIC_FILE = "DialTone.wav"
    Const CALL_PARKING_MUSIC_FILE = "Hold.wav"

    Public Sub New()
        m_objSettingDefault = New cVaxSettingDefault(Me)
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Overloads Function Initialize(ByVal sDomainRealm As String, ByVal sSIPListenIP As String, ByVal nSIPListenPort As Integer) As Boolean

        If (MyBase.Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sSIPListenIP, -1) = False) Then
            Return False
        End If

        MyBase.SetListenPortRangeRTP(20000, 30000)

        Dim objStoreCOMM As cStoreCOMM = New cStoreCOMM()
        objStoreCOMM.Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sSIPListenIP, -1)

        Return True

    End Function

    Public Function GetInitialize(ByRef sSIPListenIP As String, ByRef nSIPListenPort As Integer) As Boolean

        Dim sDomainRealm As String = ""
        Dim sRTPListenIP As String = ""
        Dim nRTPListenPort As Integer = -1

        Dim objStoreCOMM As cStoreCOMM = New cStoreCOMM()
        objStoreCOMM.GetInitialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort)
        Return True

    End Function

    Public Overloads Function LoadMusicHold(ByVal sFileName As String) As Boolean

        If (MyBase.LoadMusicHold(sFileName) = False) Then
            Return False
        End If

        Dim objStoreCOMM As cStoreCOMM = New cStoreCOMM()
        Return objStoreCOMM.SetMusicHold(sFileName)

    End Function

    Public Function GetMusicHold() As String

        Dim sFileName As String = ""
        Dim objStoreCOMM As cStoreCOMM = New cStoreCOMM()

        If (objStoreCOMM.GetMusicHold(sFileName) = False) Then
            sFileName = HOLD_MUSIC_FILE
        End If

        Return sFileName

    End Function

    Public Overloads Function LoadMusicDialTone(ByVal sFileName As String) As Boolean

        If (MyBase.LoadMusicDialTone(sFileName) = False) Then
            Return False
        End If

        Dim objStoreCOMM As cStoreCOMM = New cStoreCOMM()
        Return objStoreCOMM.SetMusicDialTone(sFileName)

    End Function

    Public Function GetMusicDialTone() As String

        Dim sFileName As String = ""

        Dim objStoreCOMM As cStoreCOMM = New cStoreCOMM()
        If (objStoreCOMM.GetMusicDialTone(sFileName) = False) Then
            sFileName = DIAL_TONE_MUSIC_FILE
        End If

        Return sFileName

    End Function

    Public Overloads Function LoadMusicCallParking(ByVal sFileName As String) As Boolean

        If (MyBase.LoadMusicCallPark(sFileName) = False) Then
            Return False
        End If

        Dim objStoreCOMM As cStoreCOMM = New cStoreCOMM()
        Return objStoreCOMM.SetMusicCallParking(sFileName)

    End Function

    Public Function GetMusicCallParking() As String

        Dim sFileName As String = ""

        Dim objStoreCOMM As cStoreCOMM = New cStoreCOMM()
        If (objStoreCOMM.GetMusicCallParking(sFileName) = False) Then
            sFileName = CALL_PARKING_MUSIC_FILE
        End If

        Return sFileName

    End Function

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddUser(ByVal sLogin As String, ByVal sPassword As String, ByVal sCodecList As String, ByVal bBlocked As Boolean, ByVal sUserPrefix As String, ByVal sDialPrefix As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bStealthListen As Boolean) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        If (sLogin.Length = 0) Then
            Return False
        End If

        RemoveUser(sLogin)

        Dim objStoreUser As cStoreUser = New cStoreUser()
        objStoreUser.AddUser(sLogin, sPassword, sCodecList, bBlocked, bStealthListen)

        If (sUserPrefix.Length <> 0 Or sDialPrefix.Length <> 0) Then
            objStoreUser.AddUserRoute(sLogin, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)
            MyBase.AddUserRoute(sLogin, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)
        End If

        Return MyBase.AddUser(sLogin, sPassword, sCodecList, bBlocked, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName, bStealthListen)

    End Function

    Public Overloads Sub RemoveUser(ByVal sLogin As String)

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objStoreUser As cStoreUser = New cStoreUser()

        objStoreUser.RemoveUserRoute(sLogin)
        objStoreUser.RemoveUser(sLogin)

        MyBase.RemoveUser(sLogin)
        MyBase.RemoveUserRoute(sLogin)

    End Sub

    Public Sub GetUserNameAll(ByRef objList As ArrayList)

        Dim objListUser As List(Of String) = New List(Of String)

        Dim objStoreUser As cStoreUser = New cStoreUser()
        objStoreUser.GetUserNameAll(objListUser)

        objList.AddRange(objListUser)

    End Sub

    Public Overloads Function GetUserDetails(ByVal sUserName As String, ByRef sPassword As String, ByRef sCodecList As String, ByRef bBlocked As Boolean, ByRef bStealthListen As Boolean, ByRef sUserPrefix As String, ByRef sDialPrefix As String, ByRef nToPeerType As Integer, ByRef sToPeerName As String) As Boolean

        Dim objStoreUser As cStoreUser = New cStoreUser()
        objStoreUser.GetUser(sUserName, sPassword, sCodecList, bBlocked, bStealthListen)
        objStoreUser.GetUserRoute(sUserName, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)
        Return True

    End Function

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddLine(ByVal sLineName As String, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sProxySIP As String, ByVal sCodecList As String, ByVal bRegister As Boolean, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String, ByVal sQueueName As String, ByVal sRingGroupName As String) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        RemoveLine(sLineName)

        Dim objStoreLine As cStoreLine = New cStoreLine()
        objStoreLine.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, "", sCodecList, bRegister)
        objStoreLine.AddLineRoute(sLineName, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)

        MyBase.AddLineRoute(sLineName, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)
        Return MyBase.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, bRegister, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)

    End Function

    Public Overloads Sub RemoveLine(ByVal sLineName As String)
        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objStoreLine As cStoreLine = New cStoreLine()
        objStoreLine.RemoveLineRoute(sLineName)
        objStoreLine.RemoveLine(sLineName)

        MyBase.RemoveLine(sLineName)
        MyBase.RemoveLineRoute(sLineName)

    End Sub

    Public Overloads Sub GetLineAll(ByRef arrLineList As ArrayList)

        Dim objListLine As List(Of String) = New List(Of String)
        Dim objStoreLine As cStoreLine = New cStoreLine()
        objStoreLine.GetLineNameAll(objListLine)

        arrLineList.AddRange(objListLine)

    End Sub

    Public Overloads Function GetLineDetails(ByVal sLineName As String, ByRef sDisplayName As String, ByRef sUserName As String, ByRef sAuthUser As String, ByRef sAuthPwd As String, ByRef sDomainRealm As String, ByRef sProxySIP As String, ByRef sCodecList As String, ByRef bRegister As Boolean, ByRef nToPeerType As Integer, ByRef sToPeerName As String, ByRef bRejectCall As Boolean, ByRef sRoomName As String, ByRef sQueueName As String, ByRef sRingGroupName As String) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        Dim objStoreLine As cStoreLine = New cStoreLine()
        objStoreLine.GetLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, "", sCodecList, bRegister)
        objStoreLine.GetLineRoute(sLineName, nToPeerType, sToPeerName, bRejectCall, sRoomName, sQueueName, sRingGroupName)

        Return True

    End Function

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddDirectProxySIP(ByVal sProxyName As String, ByVal sAuthLogin As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sProxyIP As String, ByVal nProxyPort As Integer, ByVal sCodecList As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String, ByVal sQueueName As String, ByVal sRingGroupName As String) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        RemoveDirectProxySIP(sProxyName)

        Dim objStoreProxy As cStoreDirectProxy = New cStoreDirectProxy()

        objStoreProxy.AddDirectProxySIP(sProxyName, sAuthLogin, "", sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList)
        objStoreProxy.AddDirectProxyRoute(sProxyName, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)


        MyBase.AddDirectProxyRoute(sProxyName, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)
        Return MyBase.AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)

    End Function

    Public Overloads Sub RemoveDirectProxySIP(ByVal sProxyName As String)

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objStoreProxy As cStoreDirectProxy = New cStoreDirectProxy()
        objStoreProxy.RemoveDirectProxySIP(sProxyName)

        MyBase.RemoveDirectProxyRoute(sProxyName)
        MyBase.RemoveDirectProxySIP(sProxyName)

    End Sub


    Public Sub GetDirectProxyAll(ByRef arrProxyList As ArrayList)

        Dim objListProxy As List(Of String) = New List(Of String)

        Dim objStoreProxy As cStoreDirectProxy = New cStoreDirectProxy()
        objStoreProxy.GetDirectProxySIPAll(objListProxy)

        arrProxyList.AddRange(objListProxy)

    End Sub

    Public Function GetDirectProxyDetails(ByVal sProxyName As String, ByRef sAuthLogin As String, ByRef sAuthPwd As String, ByRef sDomainRealm As String, ByRef sProxyIP As String, ByRef nProxyPort As Integer, ByRef sCodecList As String, ByRef nToPeerType As Integer, ByRef sToPeerName As String, ByRef bRejectCall As Boolean, ByRef sRoomName As String, ByRef sQueueName As String, ByRef sRingGroupName As String) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        Dim objStoreProxy As cStoreDirectProxy = New cStoreDirectProxy()
        objStoreProxy.GetDirectProxySIP(sProxyName, sAuthLogin, "", sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList)
        objStoreProxy.GetDirectProxyRoute(sProxyName, nToPeerType, sToPeerName, bRejectCall, sRoomName, sQueueName, sRingGroupName)

        Return True

    End Function


    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddRoom(ByVal sRoomName As String, ByVal sRoomNo As String) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        RemoveRoom(sRoomName)

        If (MyBase.AddRoom(sRoomName, sRoomNo) = False) Then
            Return False
        End If

        Dim objStoreRoom As cStoreRoom = New cStoreRoom()
        objStoreRoom.AddRoom(sRoomName, sRoomNo)

        Return True

    End Function

    Public Overloads Sub RemoveRoom(ByVal sRoomName As String)

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objStoreRoom As cStoreRoom = New cStoreRoom()
        objStoreRoom.RemoveRoom(sRoomName)

        MyBase.RemoveRoom(sRoomName)

    End Sub

    Public Function GetRoomDetails(ByVal sRoomName As String, ByRef sRoomNo As String) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        Dim objStoreRoom As cStoreRoom = New cStoreRoom()
        objStoreRoom.GetRoom(sRoomName, sRoomNo)

        Return True

    End Function

    Public Function GetRoomAll(ByRef arrRoomName As ArrayList) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        Dim objListRoom As List(Of String) = New List(Of String)

        Dim objStoreRoom As cStoreRoom = New cStoreRoom()
        objStoreRoom.GetRoomAll(objListRoom)

        If (objListRoom.Count > 0) Then
            arrRoomName.AddRange(objListRoom)
        End If

        Return True

    End Function

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddQueue(ByVal sQueueName As String, ByVal sQueueMusicFile As String, ByVal sQueueDialToneFile As String) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        If (sQueueName.Length = 0) Then
            Return False
        End If

        If (MyBase.AddQueue(sQueueName, sQueueMusicFile, sQueueDialToneFile) = False) Then
            Return False
        End If

        Dim objStoreQueue As cStoreQueue = New cStoreQueue()

        objStoreQueue.AddQueue(sQueueName)
        objStoreQueue.SetMusicFile(sQueueName, sQueueMusicFile)
        objStoreQueue.SetDialToneFile(sQueueName, sQueueDialToneFile)

        Return True

    End Function

    Public Overloads Sub RemoveQueue(ByVal sQueueName As String)

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        If (sQueueName.Length = 0) Then
            Return
        End If

        Dim objStoreQueue As cStoreQueue = New cStoreQueue()
        objStoreQueue.RemoveQueue(sQueueName)

        MyBase.RemoveQueue(sQueueName)

    End Sub

    Public Function GetQueueNameAll(ByRef sListQueueName As List(Of String)) As Boolean

        Dim objStoreQueue As cStoreQueue = New cStoreQueue()
        Return objStoreQueue.GetQueueNameAll(sListQueueName)

    End Function

    Public Function GetQueueDetails(ByVal sQueueName As String, ByRef nProcessMode As Integer, ByRef nProcessType As Integer, ByRef objListQueueAgent As List(Of String), ByRef sQueueMusicFile As String, ByRef sQueueDialToneFile As String) As Boolean

        objListQueueAgent.Clear()

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        If (sQueueName.Length = 0) Then
            Return False
        End If

        Dim objStoreQueue As cStoreQueue = New cStoreQueue()
        objStoreQueue.GetQueueProcessMode(sQueueName, nProcessMode, nProcessType)
        objStoreQueue.GetQueueAgentNameAll(sQueueName, objListQueueAgent)

        objStoreQueue.GetMusicFile(sQueueName, sQueueMusicFile)
        objStoreQueue.GetDialToneFile(sQueueName, sQueueDialToneFile)
        Return True

    End Function

    Public Overloads Function AddQueueAgent(ByVal sQueueName As String, ByVal sUserName As String) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        If (sQueueName.Length = 0 Or sUserName.Length = 0) Then
            Return False
        End If

        If (MyBase.AddQueueAgent(sQueueName, sUserName) = False) Then
            Return False
        End If
        Dim objStoreQueue As cStoreQueue = New cStoreQueue()
        objStoreQueue.AddQueueAgent(sQueueName, sUserName)

        Return True

    End Function

    Public Overloads Sub RemoveQueueAgent(ByVal sQueueName As String, ByVal sUserName As String)

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        If (sQueueName.Length = 0 Or sUserName.Length = 0) Then
            Return
        End If

        Dim objStoreQueue As cStoreQueue = New cStoreQueue()
        objStoreQueue.RemoveQueueAgent(sQueueName, sUserName)
        MyBase.RemoveQueueAgent(sQueueName, sUserName)

    End Sub

    Public Overloads Sub SetQueueAgentPriority(ByVal sQueueName As String, ByVal sUserName As String, ByVal nPriorityWeight As Integer)

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        If (sQueueName.Length = 0 Or sUserName.Length = 0) Then
            Return
        End If

        Dim objStoreQueue As cStoreQueue = New cStoreQueue()
        objStoreQueue.SetQueueAgentPriority(sQueueName, sUserName, nPriorityWeight)

        MyBase.SetQueueAgentPriority(sQueueName, sUserName, nPriorityWeight)

    End Sub

    Public Overloads Sub SetQueueProcessMode(ByVal sQueueName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer)

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        If (sQueueName.Length = 0) Then
            Return
        End If

        Dim objStoreQueue As cStoreQueue = New cStoreQueue()
        objStoreQueue.SetQueueProcessMode(sQueueName, nProcessMode, nProcessType)

        MyBase.SetQueueProcessMode(sQueueName, nProcessMode, nProcessType)

    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddRingGroup(ByVal sRingGroupName As String) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        If (sRingGroupName.Length = 0) Then
            Return False
        End If

        If (MyBase.AddRingGroup(sRingGroupName) = False) Then
            Return False
        End If

        Dim objStoreRingGroup As cStoreRingGroup = New cStoreRingGroup()
        objStoreRingGroup.AddRingGroup(sRingGroupName)
        Return True

    End Function

    Public Overloads Sub RemoveRingGroup(ByVal sRingGroupName As String)

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        If (sRingGroupName.Length = 0) Then
            Return
        End If

        Dim objStoreRingGroup As cStoreRingGroup = New cStoreRingGroup()
        objStoreRingGroup.RemoveRingGroup(sRingGroupName)

        MyBase.RemoveRingGroup(sRingGroupName)

    End Sub

    Public Function GetRingGroupNameAll(ByRef objListGroupName As List(Of String)) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        objListGroupName.Clear()
        Dim objStoreRingGroup As cStoreRingGroup = New cStoreRingGroup()
        Return objStoreRingGroup.GetRingGroupList(objListGroupName)

    End Function


    Public Function GetRingGroupDetails(ByVal sRingGroupName As String, ByRef nProcessMode As Integer, ByRef nProcessType As Integer, ByRef objListRingGroupAgentName As List(Of String)) As Boolean

        objListRingGroupAgentName.Clear()

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        If (sRingGroupName.Length = 0) Then
            Return False
        End If

        Dim objStoreRingGroup As cStoreRingGroup = New cStoreRingGroup()
        objStoreRingGroup.GetRingGroupProcessMode(sRingGroupName, nProcessMode, nProcessType)
        objStoreRingGroup.GetRingGroupAgentList(sRingGroupName, objListRingGroupAgentName)

        Return True

    End Function

    Public Overloads Function AddRingGroupAgent(ByVal sRingGroupName As String, ByVal sUserName As String) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        If (sRingGroupName.Length = 0 Or sUserName.Length = 0) Then
            Return False
        End If

        If (MyBase.AddRingGroupAgent(sRingGroupName, sUserName) = False) Then
            Return False
        End If

        Dim objStoreRingGroup As cStoreRingGroup = New cStoreRingGroup()
        objStoreRingGroup.AddRingGroupAgent(sRingGroupName, sUserName)

        Return True

    End Function

    Public Overloads Sub RemoveRingGroupAgent(ByVal sRingGroupName As String, ByVal sUserName As String)

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        If (sRingGroupName.Length = 0 Or sUserName.Length = 0) Then
            Return
        End If

        Dim objStoreRingGroup As cStoreRingGroup = New cStoreRingGroup()
        objStoreRingGroup.RemoveRingGroupAgent(sRingGroupName, sUserName)
        MyBase.RemoveRingGroupAgent(sRingGroupName, sUserName)

    End Sub

    Public Overloads Sub SetRingGroupAgentPriority(ByVal sRingGroupName As String, ByVal sUserName As String, ByVal nPriorityWeight As Integer)

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        If (sRingGroupName.Length = 0 Or sUserName.Length = 0) Then
            Return
        End If

        Dim objStoreRingGroup As cStoreRingGroup = New cStoreRingGroup()
        objStoreRingGroup.SetRingGroupAgentPriority(sRingGroupName, sUserName, nPriorityWeight)

        MyBase.SetRingGroupAgentPriority(sRingGroupName, sUserName, nPriorityWeight)

    End Sub

    Public Overloads Sub SetRingGroupProcessMode(ByVal sRingGroupName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer)

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        If (sRingGroupName.Length = 0) Then
            Return
        End If

        Dim objStoreRingGroup As cStoreRingGroup = New cStoreRingGroup()
        objStoreRingGroup.SetRingGroupProcessMode(sRingGroupName, nProcessMode, nProcessType)

        MyBase.SetRingGroupProcessMode(sRingGroupName, nProcessMode, nProcessType)

    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddCallPickUpGroup(ByVal sCallPickUpGroupName As String) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        If (sCallPickUpGroupName.Length = 0) Then
            Return False
        End If

        If (MyBase.AddCallPickUpGroup(sCallPickUpGroupName) = False) Then
            Return False
        End If

        Dim objStoreCallPickUp As cStoreCallPickUp = New cStoreCallPickUp()
        objStoreCallPickUp.AddCallPickUpGroup(sCallPickUpGroupName)
        Return True

    End Function

    Public Overloads Sub RemoveCallPickUpGroup(ByVal sCallPickUpGroupName As String)

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        If (sCallPickUpGroupName.Length = 0) Then
            Return
        End If

        MyBase.RemoveCallPickUpGroup(sCallPickUpGroupName)

        Dim objStoreCallPickUp As cStoreCallPickUp = New cStoreCallPickUp()
        objStoreCallPickUp.RemoveCallPickUpGroup(sCallPickUpGroupName)

    End Sub

    Public Function GetPickUpGroupNameAll(ByRef objListPickUpName As List(Of String)) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        objListPickUpName.Clear()
        Dim objStoreCallPickUp As cStoreCallPickUp = New cStoreCallPickUp()
        Return objStoreCallPickUp.GetCallPickUpGroupNameAll(objListPickUpName)

    End Function

    Public Overloads Function AddCallPickUpGroupMember(ByVal sCallPickUpGroupName As String, ByVal sMemberName As String) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        If (sCallPickUpGroupName.Length = 0 Or sMemberName.Length = 0) Then
            Return False
        End If

        If (MyBase.AddCallPickUpGroupMember(sCallPickUpGroupName, sMemberName) = False) Then
            Return False
        End If

        Dim objStoreCallPickUp As cStoreCallPickUp = New cStoreCallPickUp()
        objStoreCallPickUp.AddCallPickUpGroupMember(sCallPickUpGroupName, sMemberName)

        Return True
    End Function

    Public Overloads Sub RemoveCallPickUpMember(ByVal sCallPickUpGroupName As String, ByVal sMemberName As String)

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        If (sCallPickUpGroupName.Length = 0 Or sMemberName.Length = 0) Then
            Return
        End If

        Dim objStoreCallPickUp As cStoreCallPickUp = New cStoreCallPickUp()
        objStoreCallPickUp.RemoveCallPickUpGroupMember(sCallPickUpGroupName, sMemberName)

        MyBase.RemoveCallPickUpGroupMember(sCallPickUpGroupName, sMemberName)

    End Sub

    Public Function GetPickUpMemberNameAll(ByVal sCallPickUpGroupName As String, ByRef objListPickUpMemberName As List(Of String)) As Boolean

        objListPickUpMemberName.Clear()

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        If (sCallPickUpGroupName.Length = 0) Then
            Return False
        End If

        Dim objStoreCallPickUp As cStoreCallPickUp = New cStoreCallPickUp()
        Return objStoreCallPickUp.GetPickUpMemberNameAll(sCallPickUpGroupName, objListPickUpMemberName)

    End Function

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Private Sub LoadUser()

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objListUsers As List(Of String) = New List(Of String)
        Dim objStoreUser As cStoreUser = New cStoreUser()
        objStoreUser.GetUserNameAll(objListUsers)

        If (objListUsers.Count = 0) Then
            Return
        End If

        Dim sPassword As String = ""
        Dim sCodecList As String = ""
        Dim sUserPrefix As String = ""
        Dim sDialPrefix As String = ""
        Dim sToPeerName As String = ""

        Dim bBlocked As Boolean = False
        Dim bStealthListen As Boolean = False
        Dim nToPeerType As Integer = -1

        For Each sUserName As String In objListUsers

            objStoreUser.GetUser(sUserName, sPassword, sCodecList, bBlocked, bStealthListen)
            objStoreUser.GetUserRoute(sUserName, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)

            If (sUserPrefix.Length <> 0 Or sDialPrefix.Length <> 0) Then
                MyBase.AddUserRoute(sUserName, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)
            End If

            MyBase.AddUser(sUserName, sPassword, sCodecList, bBlocked, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName, bStealthListen)

        Next
    End Sub

    Private Sub LoadLine()

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objListLines As List(Of String) = New List(Of String)
        Dim objStoreLine As cStoreLine = New cStoreLine()
        objStoreLine.GetLineNameAll(objListLines)

        If (objListLines.Count = 0) Then
            Return
        End If

        Dim sDisplayName As String = ""
        Dim sUserName As String = ""
        Dim sAuthUser As String = ""
        Dim sAuthPwd As String = ""
        Dim sDomainRealm As String = ""
        Dim sProxySIP As String = ""
        Dim sCodecList As String = ""
        Dim sOutboundProxySIP As String = ""
        Dim sToPeerName As String = ""
        Dim sRoomName As String = ""
        Dim sQueueName As String = ""
        Dim sRingGroupName As String = ""

        Dim bRegister As Boolean = False
        Dim bRejectCall As Boolean = False

        Dim nToPeerType As Integer = -1

        For Each sLineName As String In objListLines

            objStoreLine.GetLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sOutboundProxySIP, sCodecList, bRegister)
            objStoreLine.GetLineRoute(sUserName, nToPeerType, sToPeerName, bRejectCall, sRoomName, sQueueName, sRingGroupName)

            MyBase.AddLineRoute(sLineName, nToPeerType, sToPeerName, bRejectCall, sRoomName, sQueueName, sRingGroupName)
            MyBase.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, bRegister, nToPeerType, sToPeerName, bRejectCall, sRoomName, sQueueName, sRingGroupName)
        Next
    End Sub

    Private Sub LoadDirectProxy()

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objListProxy As List(Of String) = New List(Of String)
        Dim objStoreProxy As cStoreDirectProxy = New cStoreDirectProxy()
        objStoreProxy.GetDirectProxySIPAll(objListProxy)

        If (objListProxy.Count = 0) Then
            Return
        End If

        Dim sAuthLogin As String = ""
        Dim sUserName As String = ""
        Dim sAuthPwd As String = ""
        Dim sDomainRealm As String = ""
        Dim sProxyIP As String = ""
        Dim sCodecList As String = ""
        Dim sToPeerName As String = ""
        Dim sRoomName As String = ""
        Dim sOutboundProxySIP As String = ""
        Dim sQueueName As String = ""
        Dim sRingGroupName As String = ""

        Dim bRejected As Boolean = False

        Dim nProxyPort As Integer = -1
        Dim nToPeerType As Integer = -1

        For Each sProxy As String In objListProxy

            objStoreProxy.GetDirectProxySIP(sProxy, sAuthLogin, sUserName, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList)
            objStoreProxy.GetDirectProxyRoute(sProxy, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)

            MyBase.AddDirectProxyRoute(sProxy, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)
            MyBase.AddDirectProxySIP(sProxy, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)

        Next
    End Sub

    Private Sub LoadRoom()

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objListRoom As List(Of String) = New List(Of String)
        Dim objStoreRoom As cStoreRoom = New cStoreRoom()
        objStoreRoom.GetRoomAll(objListRoom)

        If (objListRoom.Count = 0) Then
            Return
        End If

        Dim sRoomNo As String = ""
        For Each sRoomName As String In objListRoom

            objStoreRoom.GetRoom(sRoomName, sRoomNo)
            MyBase.AddRoom(sRoomName, sRoomNo)

        Next
    End Sub

    Private Sub LoadQueue()

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objListQueue As List(Of String) = New List(Of String)
        Dim objStoreQueue As cStoreQueue = New cStoreQueue()
        objStoreQueue.GetQueueNameAll(objListQueue)

        If (objListQueue.Count = 0) Then
            Return
        End If

        Dim objListQueueAgent As List(Of String) = New List(Of String)

        Dim sQueueMusicFile As String = ""
        Dim sQueueDialToneMusic As String = ""

        Dim nProcessMode As Integer = -1
        Dim nProcessType As Integer = -1

        For Each sQueueName As String In objListQueue

            objStoreQueue.GetMusicFile(sQueueName, sQueueMusicFile)
            objStoreQueue.GetDialToneFile(sQueueName, sQueueDialToneMusic)
            objStoreQueue.GetQueueAgentNameAll(sQueueName, objListQueueAgent)
            objStoreQueue.GetQueueProcessMode(sQueueName, nProcessMode, nProcessType)

            MyBase.AddQueue(sQueueName, sQueueMusicFile, sQueueDialToneMusic)
            MyBase.SetQueueProcessMode(sQueueName, nProcessMode, nProcessType)

            AddQueueAgents(sQueueName, objListQueueAgent)
            objListQueueAgent.Clear()

        Next
    End Sub

    Private Sub AddQueueAgents(ByVal sQueueName As String, ByVal objListQueueAgent As List(Of String))

        Dim objStoreQueue As cStoreQueue = New cStoreQueue()
        Dim nPriority As Integer = -1

        For Each sQueueAgentName As String In objListQueueAgent

            objStoreQueue.GetQueueAgentPriority(sQueueName, sQueueAgentName, nPriority)
            MyBase.AddQueueAgent(sQueueName, sQueueAgentName)
            MyBase.SetQueueAgentPriority(sQueueName, sQueueAgentName, nPriority)

        Next
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////

    Private Sub LoadRingGroup()

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objListRingGroup As List(Of String) = New List(Of String)
        Dim objStoreRingGroup As cStoreRingGroup = New cStoreRingGroup()
        objStoreRingGroup.GetRingGroupList(objListRingGroup)

        If (objListRingGroup.Count = 0) Then
            Return
        End If

        Dim objListRingGroupAgent As List(Of String) = New List(Of String)

        Dim nProcessMode As Integer = -1
        Dim nProcessType As Integer = -1

        For Each sRingGroupName As String In objListRingGroup

            objStoreRingGroup.GetRingGroupAgentList(sRingGroupName, objListRingGroupAgent)
            objStoreRingGroup.GetRingGroupProcessMode(sRingGroupName, nProcessMode, nProcessType)

            MyBase.AddRingGroup(sRingGroupName)
            MyBase.SetRingGroupProcessMode(sRingGroupName, nProcessMode, nProcessType)

            AddRingGroupAgents(sRingGroupName, objListRingGroupAgent)
            objListRingGroupAgent.Clear()

        Next
    End Sub

    Private Sub AddRingGroupAgents(ByVal sRingGroupName As String, ByVal objListRingGroupAgent As List(Of String))

        Dim objStoreRingGroup As cStoreRingGroup = New cStoreRingGroup()
        Dim nPriority As Integer = -1

        For Each sRingGroupAgentName As String In objListRingGroupAgent

            objStoreRingGroup.GetRingGroupAgentPriority(sRingGroupName, sRingGroupAgentName, nPriority)
            MyBase.AddRingGroupAgent(sRingGroupName, sRingGroupAgentName)
            MyBase.SetRingGroupAgentPriority(sRingGroupName, sRingGroupAgentName, nPriority)

        Next
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////

    Private Sub LoadCallPickupGroup()

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objListCallPickup As List(Of String) = New List(Of String)
        Dim objStoreCallPickUp As cStoreCallPickUp = New cStoreCallPickUp()
        objStoreCallPickUp.GetCallPickUpGroupNameAll(objListCallPickup)

        If (objListCallPickup.Count = 0) Then
            Return
        End If

        Dim objListCallPickupAgent As List(Of String) = New List(Of String)
        For Each sPickupGroupName As String In objListCallPickup

            objStoreCallPickUp.GetPickUpMemberNameAll(sPickupGroupName, objListCallPickupAgent)

            MyBase.AddCallPickUpGroup(sPickupGroupName)

            AddPickupGroupAgents(sPickupGroupName, objListCallPickupAgent)
            objListCallPickupAgent.Clear()

        Next
    End Sub

    Private Sub AddPickupGroupAgents(ByVal sPickupGroupName As String, ByVal objListCallPickupAgent As List(Of String))

        For Each sPickupAgent As String In objListCallPickupAgent
            MyBase.AddCallPickUpGroupMember(sPickupGroupName, sPickupAgent)
        Next
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnInitialize()

        If (Not m_objSettingDefault.LoadUserDefault()) Then
            LoadUser()
        End If

        If (Not m_objSettingDefault.LoadLineDefault()) Then
            LoadLine()
        End If

        If (Not m_objSettingDefault.LoadRoomDefault()) Then
            LoadRoom()
        End If

        LoadDirectProxy()

        If (Not m_objSettingDefault.LoadQueueDefault()) Then
            LoadQueue()
        End If

        If (Not m_objSettingDefault.LoadRingGroupDefault()) Then
            LoadRingGroup()
        End If

        If (Not m_objSettingDefault.LoadCallPickUpGroupDefault()) Then
            LoadCallPickupGroup()
        End If

    End Sub

    Public Overrides Sub OnErrorLog(ByVal sMsg As String)

        MainForm.m_objMainForm.PostErrorLog(sMsg)

    End Sub

    Public Overrides Sub OnStatusLog(ByVal sMsg As String)

        MainForm.m_objMainForm.PostStatusLog(sMsg)

    End Sub

End Class
