#pragma once

//------------------------------------------------------------------------------------------
//-------------			CCallPickUpDetails
//------------------------------------------------------------------------------------------
class CCallPickUpMemberList;

class CCallPickUpDetails
{

public:

	CCallPickUpDetails(LPCTSTR sPickUpGroupName);
	~CCallPickUpDetails();

public:

	CCallPickUpMemberList* m_pMemberList;
	CString m_sPickUpGroupName;

public:

	BOOL AddCallPickUpGroupMember(LPCTSTR sMemberName);
	void RemoveCallPickUpGroupMember(LPCTSTR sMemberName);

	BOOL GetPickUpMemberList(CStringList& sListMemberName);
	BOOL IsGroupMember(LPCTSTR sMemberName);

};

typedef CMap<CString, LPCTSTR, CCallPickUpDetails*, CCallPickUpDetails*> CCallPickUpDetailsList;

//------------------------------------------------------------------------------------------
//-------------			CallPickUpList
//------------------------------------------------------------------------------------------

class CCallPickUpList
{

public:

	CCallPickUpList(void);
	~CCallPickUpList(void);

public:

	CCallPickUpDetailsList* m_pCallPickUpDetailsList;

private:

	CString GenKey(LPCTSTR sPickUpGroupName);

public:

	BOOL AddCallPickUpGroup(LPCTSTR sPickUpGroupName);
	void RemoveCallPickUpGroup(LPCTSTR sPickUpGroupName);

	BOOL AddCallPickUpGroupMember(LPCTSTR sPickUpGroupName, LPCTSTR sMemberName);
	void RemoveCallPickUpGroupMember(LPCTSTR sPickUpGroupName, LPCTSTR sMemberName);

	CCallPickUpDetails* FindCallPickUp(LPCTSTR sPickUpGroupName);

	BOOL GetAllPickUpGroupName(CStringList& sListPickUpName);
	BOOL GetPickUpMemberName(LPCTSTR sPickUpGroupName, CStringList& sListMemberName);

	BOOL IsGroupMember(LPCTSTR sPickUpGroupName, LPCTSTR sMemberName);
	
	void DeletePickUpGroupAll();
};

