﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

using VaxTeleServerCOMLib;

public class cVaxServerCOM
{
    public const int VAX_PEER_TYPE_USER = 3001;
    public const int VAX_PEER_TYPE_LINE = 3002;
    public const int VAX_PEER_TYPE_DIRECT_PROXY = 3003;

    public const int TYPE_VOICE_NORMAL = 100;
    public const int TYPE_VOICE_USER = 101;
    public const int TYPE_VOICE_ADMIN = 102;

    public const int VAX_CLOSED_REASON_CODE_HANGUP = 2001;
    public const int VAX_CLOSED_REASON_CODE_SESSION_LOST = 2002;
    public const int VAX_CLOSED_REASON_CODE_MOVED = 2003;
    public const int VAX_CLOSED_REASON_CODE_TRANSFERED = 2004;
    public const int VAX_CLOSED_REASON_CODE_REJECTED = 2005;
    public const int VAX_CLOSED_REASON_CODE_FAILED = 2006;
    public const int VAX_CLOSED_REASON_CODE_CANCELLED = 2007;
    public const int VAX_CLOSED_REASON_CODE_TIMEOUT = 2008;
    public const int VAX_CLOSED_REASON_CODE_CLOSED = 2009;

    public const int VAX_CALL_CHANNEL_ZERO = 0;
    public const int VAX_CALL_CHANNEL_ONE = 1;

    public const int VAX_CUSTOM_HEADER_REQ_ID_INVITE = 0;

    public const int DTMF_TYPE_RFC2833 = 0;
    public const int DTMF_TYPE_INBAND = 1;
    public const int DTMF_TYPE_INFO = 2;

    public const int VAX_TRANSFER_TYPE_BLIND = 401;
    public const int VAX_TRANSFER_TYPE_CONSULT = 402;

    public const int PLAY_WAVE_MODE_EXCLUSIVE = 0;
    public const int PLAY_WAVE_MODE_MIXED = 1;

    public const int VAX_CODEC_GSM610 = 0;
    public const int VAX_CODEC_ILBC = 1;
    public const int VAX_CODEC_G711A = 2;
    public const int VAX_CODEC_G711U = 3;
    public const int VAX_CODEC_G729 = 4;

///////////////////////////////////////////////////////////

    public const int VAX_QUEUE_ALGO_HUNT_RANDOM	 = 0;
    public const int VAX_QUEUE_ALGO_FEWEST_ANSWERED = 1;
    public const int VAX_QUEUE_ALGO_LEAST_TALK_TIME	= 2;
    public const int VAX_QUEUE_ALGO_LONGEST_WAIT_TIME =	3;
    public const int VAX_QUEUE_ALGO_PRIORITIZED_HUNT = 4;
    public const int VAX_QUEUE_ALGO_ROUND_ROBIN = 5;

    public const int VAX_QUEUE_MODE_TYPE_FREE = 0;
    public const int VAX_QUEUE_MODE_TYPE_ANY =  1;
        
    public const int VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_MUSIC = 0;
    public const int VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_RING = 1;
        
    public const int VAX_QUEUE_AGENT_AVAILABLE_STATUS = 0;
    public const int VAX_QUEUE_AGENT_UNAVAILABLE_STATUS = 1;
    
/////////////////////////////////////////////////////////

    public const int VAX_RING_GROUP_ALGO_RING_ALL = 0;
    public const int VAX_RING_GROUP_ALGO_HUNT_RANDOM = 1;
    public const int VAX_RING_GROUP_ALGO_ROUND_ROBIN = 2;
    public const int VAX_RING_GROUP_ALGO_LEAST_ANSWERED = 3;
    public const int VAX_RING_GROUP_ALGO_LEAST_TALK_TIME = 4;
    public const int VAX_RING_GROUP_ALGO_LONGEST_WAITING = 5;
    public const int VAX_RING_GROUP_ALGO_PRIORITIZED_HUNT = 6;

    public const int VAX_RING_GROUP_MODE_FREE = 0;
    public const int VAX_RING_GROUP_MODE_ANY  = 1;

////////////////////////////////////////////////////////////////
        
    private VaxServerSIP m_objVaxServerSIP = new VaxServerSIP();
                        
    public cVaxServerCOM()
    {
        m_objVaxServerSIP.OnLineRegisterTrying += new _IVaxServerSIPEvents_OnLineRegisterTryingEventHandler(OnLineRegisterTrying);
        m_objVaxServerSIP.OnLineRegisterFailed += new _IVaxServerSIPEvents_OnLineRegisterFailedEventHandler(OnLineRegisterFailed);
        m_objVaxServerSIP.OnLineRegisterSuccess += new _IVaxServerSIPEvents_OnLineRegisterSuccessEventHandler(OnLineRegisterSuccess);

        m_objVaxServerSIP.OnLineUnRegisterTrying += new _IVaxServerSIPEvents_OnLineUnRegisterTryingEventHandler(OnLineUnRegisterTrying);
        m_objVaxServerSIP.OnLineUnRegisterFailed += new _IVaxServerSIPEvents_OnLineUnRegisterFailedEventHandler(OnLineUnRegisterFailed);
        m_objVaxServerSIP.OnLineUnRegisterSuccess += new _IVaxServerSIPEvents_OnLineUnRegisterSuccessEventHandler(OnLineUnRegisterSuccess);
        
        m_objVaxServerSIP.OnUnRegisterUser += new _IVaxServerSIPEvents_OnUnRegisterUserEventHandler(OnUnRegisterUser);
        m_objVaxServerSIP.OnRegisterUser += new _IVaxServerSIPEvents_OnRegisterUserEventHandler(OnRegisterUser);
        m_objVaxServerSIP.OnRegisterUserSuccess += new _IVaxServerSIPEvents_OnRegisterUserSuccessEventHandler(OnRegisterUserSuccess);
        m_objVaxServerSIP.OnRegisterUserFailed += new _IVaxServerSIPEvents_OnRegisterUserFailedEventHandler(OnRegisterUserFailed);
                
        m_objVaxServerSIP.OnIncomingCall +=new _IVaxServerSIPEvents_OnIncomingCallEventHandler(OnIncomingCall);
        m_objVaxServerSIP.OnCallSessionFailed += new _IVaxServerSIPEvents_OnCallSessionFailedEventHandler(OnCallSessionFailed);
        m_objVaxServerSIP.OnCallSessionConnecting += new _IVaxServerSIPEvents_OnCallSessionConnectingEventHandler(OnCallSessionConnecting);
        m_objVaxServerSIP.OnCallSessionConnected += new _IVaxServerSIPEvents_OnCallSessionConnectedEventHandler(OnCallSessionConnected);
        m_objVaxServerSIP.OnCallSessionClosed += new _IVaxServerSIPEvents_OnCallSessionClosedEventHandler(OnCallSessionClosed);

        m_objVaxServerSIP.OnCallSessionLost += new _IVaxServerSIPEvents_OnCallSessionLostEventHandler(OnCallSessionLost);
        m_objVaxServerSIP.OnCallSessionHangup += new _IVaxServerSIPEvents_OnCallSessionHangupEventHandler(OnCallSessionHangup);
        m_objVaxServerSIP.OnCallSessionTimeout += new _IVaxServerSIPEvents_OnCallSessionTimeoutEventHandler(OnCallSessionTimeout);
        m_objVaxServerSIP.OnCallSessionCancelled += new _IVaxServerSIPEvents_OnCallSessionCancelledEventHandler(OnCallSessionCancelled);

        m_objVaxServerSIP.OnCallSessionOnHold += new _IVaxServerSIPEvents_OnCallSessionOnHoldEventHandler(OnCallSessionOnHold);
        m_objVaxServerSIP.OnCallSessionOffHold += new _IVaxServerSIPEvents_OnCallSessionOffHoldEventHandler(OnCallSessionOffHold);

        m_objVaxServerSIP.OnCallSessionTransferBlind += new _IVaxServerSIPEvents_OnCallSessionTransferBlindEventHandler(OnCallSessionTransferBlind);
        m_objVaxServerSIP.OnCallSessionTransferConsult += new _IVaxServerSIPEvents_OnCallSessionTransferConsultEventHandler(OnCallSessionTransferConsult);

        m_objVaxServerSIP.OnCallSessionTransfering += new _IVaxServerSIPEvents_OnCallSessionTransferingEventHandler(OnCallSessionTransfering);
        m_objVaxServerSIP.OnCallSessionTransferFailed += new _IVaxServerSIPEvents_OnCallSessionTransferFailedEventHandler(OnCallSessionTransferFailed);
        m_objVaxServerSIP.OnCallSessionTransferTimeout += new _IVaxServerSIPEvents_OnCallSessionTransferTimeoutEventHandler(OnCallSessionTransferTimeout);
        m_objVaxServerSIP.OnCallSessionTransfered += new _IVaxServerSIPEvents_OnCallSessionTransferedEventHandler(OnCallSessionTransfered);

        m_objVaxServerSIP.OnChatMessageText += new _IVaxServerSIPEvents_OnChatMessageTextEventHandler(OnChatMessageText);
        m_objVaxServerSIP.OnChatMessageTyping += new _IVaxServerSIPEvents_OnChatMessageTypingEventHandler(OnChatMessageTyping);
        
        m_objVaxServerSIP.OnChatStatusSubscribe += new _IVaxServerSIPEvents_OnChatStatusSubscribeEventHandler(OnChatStatusSubscribe);

        m_objVaxServerSIP.OnChatStatusSendSubscribeSuccess +=new _IVaxServerSIPEvents_OnChatStatusSendSubscribeSuccessEventHandler(OnChatStatusSendSubscribeSuccess);
        m_objVaxServerSIP.OnChatStatusSendSubscribeFailed +=new _IVaxServerSIPEvents_OnChatStatusSendSubscribeFailedEventHandler(OnChatStatusSendSubscribeFailed);

        m_objVaxServerSIP.OnChatMessageSuccess += new _IVaxServerSIPEvents_OnChatMessageSuccessEventHandler(OnChatMessageSuccess);
        m_objVaxServerSIP.OnChatMessageFailed += new _IVaxServerSIPEvents_OnChatMessageFailedEventHandler(OnChatMessageFailed);
        m_objVaxServerSIP.OnChatMessageTimeout += new _IVaxServerSIPEvents_OnChatMessageTimeoutEventHandler(OnChatMessageTimeout);

        m_objVaxServerSIP.OnDetectedDigitDTMF += new _IVaxServerSIPEvents_OnDetectedDigitDTMFEventHandler(OnDetectedDigitDTMF);
        
        m_objVaxServerSIP.OnOutgoingDiagnosticLog += new _IVaxServerSIPEvents_OnOutgoingDiagnosticLogEventHandler(OnOutgoingDiagnosticLog);
        m_objVaxServerSIP.OnIncomingDiagnosticLog += new _IVaxServerSIPEvents_OnIncomingDiagnosticLogEventHandler(OnIncomingDiagnosticLog);

        m_objVaxServerSIP.OnVaxTeleTick += new _IVaxServerSIPEvents_OnVaxTeleTickEventHandler(OnVaxTeleTick);
        
        m_objVaxServerSIP.OnSendTimeoutVM += new _IVaxServerSIPEvents_OnSendTimeoutVMEventHandler(OnSendTimeoutVM);
        m_objVaxServerSIP.OnSendSuccessVM += new _IVaxServerSIPEvents_OnSendSuccessVMEventHandler(OnSendSuccessVM);

        m_objVaxServerSIP.OnCallSessionDialToneStart +=new _IVaxServerSIPEvents_OnCallSessionDialToneStartEventHandler(OnCallSessionDialToneStart);
        m_objVaxServerSIP.OnCallSessionDialToneStop += new _IVaxServerSIPEvents_OnCallSessionDialToneStopEventHandler(OnCallSessionDialToneStop);

        m_objVaxServerSIP.OnCallSessionPlayWaveDone += new _IVaxServerSIPEvents_OnCallSessionPlayWaveDoneEventHandler(OnCallSessionPlayWaveDone);
        m_objVaxServerSIP.OnConferenceRoomPlayWaveDone += new _IVaxServerSIPEvents_OnConferenceRoomPlayWaveDoneEventHandler(OnConferenceRoomPlayWaveDone);

        m_objVaxServerSIP.OnCallSessionCreated += new _IVaxServerSIPEvents_OnCallSessionCreatedEventHandler(OnCallSessionCreated);
                
        m_objVaxServerSIP.OnCallSessionDetectedAMD += new _IVaxServerSIPEvents_OnCallSessionDetectedAMDEventHandler(OnCallSessionDetectedAMD);

        m_objVaxServerSIP.OnCallSessionRecordedPCM += new _IVaxServerSIPEvents_OnCallSessionRecordedPCMEventHandler(OnCallSessionRecordedPCM);
        m_objVaxServerSIP.OnConferenceRoomRecordedPCM += new _IVaxServerSIPEvents_OnConferenceRoomRecordedPCMEventHandler(OnConferenceRoomRecordedPCM);

        m_objVaxServerSIP.OnBusyLampSubscribe += new _IVaxServerSIPEvents_OnBusyLampSubscribeEventHandler(OnBusyLampSubscribe);
        m_objVaxServerSIP.OnBusyLampUnSubscribe += new _IVaxServerSIPEvents_OnBusyLampUnSubscribeEventHandler(OnBusyLampUnSubscribe);
        m_objVaxServerSIP.OnBusyLampSubscribeSuccess += new _IVaxServerSIPEvents_OnBusyLampSubscribeSuccessEventHandler(OnBusyLampSubscribeSuccess);
        m_objVaxServerSIP.OnBusyLampSubscribeFailed += new _IVaxServerSIPEvents_OnBusyLampSubscribeFailedEventHandler(OnBusyLampSubscribeFailed);

        m_objVaxServerSIP.OnVaxErrorLog += new _IVaxServerSIPEvents_OnVaxErrorLogEventHandler(OnVaxErrorLog);

        m_objVaxServerSIP.OnAddCallSessionToQueueSuccess += new _IVaxServerSIPEvents_OnAddCallSessionToQueueSuccessEventHandler(OnAddCallSessionToQueueSuccess);
        m_objVaxServerSIP.OnAddCallSessionToQueueFailed += new _IVaxServerSIPEvents_OnAddCallSessionToQueueFailedEventHandler(OnAddCallSessionToQueueFailed);	

        m_objVaxServerSIP.OnAddCallSessionToRingGroupSuccess +=new _IVaxServerSIPEvents_OnAddCallSessionToRingGroupSuccessEventHandler(OnAddCallSessionToRingGroupSuccess);
        m_objVaxServerSIP.OnAddCallSessionToRingGroupFailed += new _IVaxServerSIPEvents_OnAddCallSessionToRingGroupFailedEventHandler(OnAddCallSessionToRingGroupFailed);

        m_objVaxServerSIP.OnVaxLicenseChannel += new _IVaxServerSIPEvents_OnVaxLicenseChannelEventHandler(OnVaxLicenseChannel);
        m_objVaxServerSIP.OnSendReqTransferCallTimeout += new _IVaxServerSIPEvents_OnSendReqTransferCallTimeoutEventHandler(OnSendReqTransferCallTimeout);
        m_objVaxServerSIP.OnSendReqTransferCallAccepted += new _IVaxServerSIPEvents_OnSendReqTransferCallAcceptedEventHandler(OnSendReqTransferCallAccepted);
        m_objVaxServerSIP.OnSendReqTransferCallFailed += new _IVaxServerSIPEvents_OnSendReqTransferCallFailedEventHandler(OnSendReqTransferCallFailed);
        m_objVaxServerSIP.OnQualityReportPUBLISH += new _IVaxServerSIPEvents_OnQualityReportPUBLISHEventHandler(OnQualityReportPUBLISH);
        m_objVaxServerSIP.OnBusyLampSendStatus +=new _IVaxServerSIPEvents_OnBusyLampSendStatusEventHandler(OnBusyLampSendStatus);

        m_objVaxServerSIP.OnServerConnectingREC += new _IVaxServerSIPEvents_OnServerConnectingRECEventHandler(OnServerConnectingREC);
        m_objVaxServerSIP.OnServerConnectedREC += new _IVaxServerSIPEvents_OnServerConnectedRECEventHandler(OnServerConnectedREC);
        m_objVaxServerSIP.OnServerFailedREC +=new _IVaxServerSIPEvents_OnServerFailedRECEventHandler(OnServerFailedREC);
        m_objVaxServerSIP.OnServerHungupREC +=new _IVaxServerSIPEvents_OnServerHungupRECEventHandler(OnServerHungupREC);
        m_objVaxServerSIP.OnServerTimeoutREC += new _IVaxServerSIPEvents_OnServerTimeoutRECEventHandler(OnServerTimeoutREC);

        m_objVaxServerSIP.OnQueuePlayWaveStart +=new _IVaxServerSIPEvents_OnQueuePlayWaveStartEventHandler(OnQueuePlayWaveStart);
        m_objVaxServerSIP.OnQueuePlayWaveStop +=new _IVaxServerSIPEvents_OnQueuePlayWaveStopEventHandler(OnQueuePlayWaveStop);

        m_objVaxServerSIP.OnQueueAgentConnectStarted +=new _IVaxServerSIPEvents_OnQueueAgentConnectStartedEventHandler(OnQueueAgentConnectStarted);
        m_objVaxServerSIP.OnQueueAgentConnectTrying +=new _IVaxServerSIPEvents_OnQueueAgentConnectTryingEventHandler(OnQueueAgentConnectTrying);
        m_objVaxServerSIP.OnQueueAgentConnectFailed +=new _IVaxServerSIPEvents_OnQueueAgentConnectFailedEventHandler(OnQueueAgentConnectFailed);
        m_objVaxServerSIP.OnQueueAgentConnectTimeout +=new _IVaxServerSIPEvents_OnQueueAgentConnectTimeoutEventHandler(OnQueueAgentConnectTimeout);
        m_objVaxServerSIP.OnQueueAgentConnectSuccess +=new _IVaxServerSIPEvents_OnQueueAgentConnectSuccessEventHandler(OnQueueAgentConnectSuccess);

        m_objVaxServerSIP.OnSendNotifyMsgSuccess += new _IVaxServerSIPEvents_OnSendNotifyMsgSuccessEventHandler(OnSendNotifyMsgSuccess);
        m_objVaxServerSIP.OnSendNotifyMsgFailed += new _IVaxServerSIPEvents_OnSendNotifyMsgFailedEventHandler(OnSendNotifyMsgFailed);

    }

    ~cVaxServerCOM()
    {
           
    }

    #region Methods

    public string GetVersionSDK()
    {
        return m_objVaxServerSIP.GetVersionSDK();
    }

    public string GetVersionFile()
    {
        return m_objVaxServerSIP.GetVersionFile();
    }
        
    public void SetLicenseKey(string sLicenseKey) 
    {
        m_objVaxServerSIP.SetLicenseKey(sLicenseKey);
    }

    public bool Initialize(string sDomainRealm, string sSIPListenIP, int nSIPListenPort, string sRTPListenIP, int nRTPListenPort)
    {
        return m_objVaxServerSIP.Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort);
    }

    public void UnInitialize() 
    {
        m_objVaxServerSIP.UnInitialize();
    }

    public Boolean SetListenPortRangeRTP(int nListenStartPort, int nListenEndPort)
    {
        return m_objVaxServerSIP.SetListenPortRangeRTP(nListenStartPort, nListenEndPort);
    }

    public bool AddUser(string sUserName, string sPassword, string sCodecList)
    {
        return m_objVaxServerSIP.AddUser(sUserName, sPassword, sCodecList);
    }
    public void RemoveUser(string sUserName) 
    {
        m_objVaxServerSIP.RemoveUser(sUserName);
    }

    public bool AcceptRegister(int nRegId)
    {
        return m_objVaxServerSIP.AcceptRegister(nRegId);
    }
    public bool RejectRegister(int nRegId, int nStatusCode, string sReasonPhrase)
    {
        return m_objVaxServerSIP.RejectRegister(nRegId, nStatusCode, sReasonPhrase);
    }

    public bool AuthRegister(int nRegId)
    {
        return m_objVaxServerSIP.AuthRegister(nRegId);
    }

    public bool RegisterUserExpiry(int nExpiry)
    {
        return m_objVaxServerSIP.RegisterUserExpiry(nExpiry);
    }

    public bool AddLine(string sLineName, string sDisplayName, string sUserName, string sAuthUser, string sAuthPwd, string sDomainRealm, string sProxySIP, string sOutboundProxySIP, string sCodecList)
    {
        return m_objVaxServerSIP.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sOutboundProxySIP, sCodecList);
    }

    public void RemoveLine(string sLineName) 
    {
        m_objVaxServerSIP.RemoveLine(sLineName);
    }

    public bool RegisterLine(string sLineName, int nExpire)
    {
        return m_objVaxServerSIP.RegisterLine(sLineName, nExpire);
    }
    public bool UnRegisterLine(string sLineName)
    {
        return m_objVaxServerSIP.UnRegisterLine(sLineName);
    }

    public bool AddDirectProxySIP(string sProxyName, string sAuthLogin, string sAuthPwd, string sDomainRealm, string sProxyIP, int nProxyPort, string sCodecList)
    {
        return m_objVaxServerSIP.AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList);
    }
    public void RemoveDirectProxySIP(string sProxyName) 
    {
        m_objVaxServerSIP.RemoveDirectProxySIP(sProxyName);
    }

    public bool AcceptCallSession(int nSessionId, string sCallerName, string sCallerId, string sDialNo, int nToPeerType, string sToPeerName, int nTimeout)
    {
        return m_objVaxServerSIP.AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout);
    }
    public bool RejectCallSession(int nSessionId, int nStatusCode, string sReasonPhrase)
    {
        return m_objVaxServerSIP.RejectCallSession(nSessionId, nStatusCode, sReasonPhrase);
    }
    public bool CloseCallSession(int nSessionId) 
    {
        return m_objVaxServerSIP.CloseCallSession(nSessionId);
    }

    public long DialCallSession(string sCallerName, string sCallerId, string sDialNo, int nToPeerType, string sToPeerName, int nTimeout)
    {
        return m_objVaxServerSIP.DialCallSession(sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout);
    }

    public bool AcceptTransferBlind(int nTransfererSessionId, string sCallerName, string sCallerId, string sTransferTo, int nToPeerType, string sToPeerName, int nTimeout)
    {
        return m_objVaxServerSIP.AcceptTransferBlind(nTransfererSessionId, sCallerName, sCallerId, sTransferTo, nToPeerType, sToPeerName, nTimeout);
    }
    public bool AcceptTransferConsult(int nTransfererSessionId, int nTransferToSessionId)
    {
        return m_objVaxServerSIP.AcceptTransferConsult(nTransfererSessionId, nTransferToSessionId);
    }
    public void RejectTransfer(int nSessionId) 
    {
        m_objVaxServerSIP.RejectTransfer(nSessionId);
    }
    
    public bool PlayWaveStartToCallSession(int nSessionId, int nChannelId, int nWaveId, bool bLoop, int nPlayPosPCM)
    {
        return m_objVaxServerSIP.PlayWaveStartToCallSession(nSessionId, nChannelId, nWaveId, bLoop, nPlayPosPCM);
    }
        
    public void PlayWaveStopToCallSession(int nSessionId, int nChannelId, int nWaveId)
    {
        m_objVaxServerSIP.PlayWaveStopToCallSession(nSessionId, nChannelId, nWaveId);
    }

    public bool PlayWaveSetVolumeToCallSession(int nSessionId, int nChannelId, int nWaveId, int nVolume)
    {
        return m_objVaxServerSIP.PlayWaveSetVolumeToCallSession(nSessionId, nChannelId, nWaveId, nVolume);
    }

    public bool PlayWaveSetModeTypeToCallSession(int nSessionId, int nChannelId, int nPlayModeType)
    {
        return m_objVaxServerSIP.PlayWaveSetModeTypeToCallSession(nSessionId, nChannelId, nPlayModeType);
    }

    public bool RecordWaveStartToCallSession(int nSessionId,  int nChannelId, string sFileName)
    {
        return m_objVaxServerSIP.RecordWaveStartToCallSession(nSessionId, nChannelId, sFileName);
    }
        
    public void RecordWaveStopToCallSession(int nSessionId,  int nChannelId)
    {
        m_objVaxServerSIP.RecordWaveStopToCallSession(nSessionId, nChannelId);
    }
        
    public bool RecordWavePauseToCallSession(int nSessionId,   int nChannelId, bool bEnable)
    {
        return m_objVaxServerSIP.RecordWavePauseToCallSession(nSessionId, nChannelId, bEnable);
    }

    public int LoadWaveFile(string sFileName)
    {
        return m_objVaxServerSIP.LoadWaveFile(sFileName);
    }

    public int LoadWavePCM(Byte[] aDataPCM, int nSizePCM)
    {
        GCHandle hHandleGC = GCHandle.Alloc(aDataPCM, GCHandleType.Pinned);
        IntPtr AddrDataPCM = hHandleGC.AddrOfPinnedObject();
        long lDataPCM = AddrDataPCM.ToInt64();
        
        int nWaveId = m_objVaxServerSIP.LoadWavePCM(lDataPCM, nSizePCM, 0);
        
        hHandleGC.Free();
        return nWaveId;
    }
    public void UnLoadWaveFile(int nWaveId) 
    {
        m_objVaxServerSIP.UnLoadWaveFile(nWaveId);
    }

    public bool LoadMusicHold(string sFileName)
    {
        return m_objVaxServerSIP.LoadMusicHold(sFileName);
    }
    public void UnLoadMusicHold() 
    {
        m_objVaxServerSIP.UnLoadMusicHold();
    }

    public bool AcceptOnHoldRequest(int nSessionId)
    {
        return m_objVaxServerSIP.AcceptOnHoldRequest(nSessionId);
    }
    public bool AcceptOffHoldRequest(int nSessionId)
    {
        return m_objVaxServerSIP.AcceptOffHoldRequest(nSessionId);
    }

    public bool AcceptChatMessage(int nChatMsgId, int nToPeerType, string sToPeerName)
    {
        return m_objVaxServerSIP.AcceptChatMessage(nChatMsgId, nToPeerType, sToPeerName);
    }
    public void RejectChatMessage(int nChatMsgId, int nStatusCode, string sReasonPhrase)
    {
        m_objVaxServerSIP.RejectChatMessage(nChatMsgId, nStatusCode, sReasonPhrase);
    }

    public int SendChatMessageText(string sMsgFrom, string sMsgTo, string sMsgText, int nToPeerType, string sToPeerName)
    {
        return m_objVaxServerSIP.SendChatMessageText(sMsgFrom, sMsgTo, sMsgText, nToPeerType, sToPeerName);
    }

    public bool AcceptChatStatusSubscribe(int nStatusSubscribe, string sMsgFrom, string sMsgTo, int nToPeerType, string sToPeerName)
    {
        return m_objVaxServerSIP.AcceptChatStatusSubscribe(nStatusSubscribe, sMsgFrom, sMsgTo, nToPeerType, sToPeerName);
    }
    public void RejectChatStatusSubscribe(int nStatusSubscribe, string sMsgFrom, string sMsgTo) 
    {
        m_objVaxServerSIP.RejectChatStatusSubscribe(nStatusSubscribe, sMsgFrom, sMsgTo);
    }

    public bool OpenConferenceRoom(string sRoomName)
    {
        return m_objVaxServerSIP.OpenConferenceRoom(sRoomName);
    }
    public void CloseConferenceRoom(string sRoomName) 
    {
        m_objVaxServerSIP.CloseConferenceRoom(sRoomName);
    }

    public bool AddCallSessionToConferenceRoom(string sRoomName, int nSessionId, int nVoiceTypeId)
    {
        return m_objVaxServerSIP.AddCallSessionToConferenceRoom(sRoomName, nSessionId, nVoiceTypeId);
    }
    public bool RemoveCallSessionFromConferenceRoom(int nSessionId)
    {
        return m_objVaxServerSIP.RemoveCallSessionFromConferenceRoom(nSessionId);
    }

	   public bool PlayWaveStartToConferenceRoom(string sRoomName, int nWaveId, bool bLoop, int nPlayPosPCM)
    {
        return m_objVaxServerSIP.PlayWaveStartToConferenceRoom(sRoomName, nWaveId, bLoop, nPlayPosPCM);
    }
    public bool PlayWaveStopToConferenceRoom(string sRoomName, int nWaveId)
    {
        return m_objVaxServerSIP.PlayWaveStopToConferenceRoom(sRoomName, nWaveId);
    }

    public bool PlayWaveSetVolumeToConferenceRoom(string sRoomName, int nWaveId, int nVolume)
    {
        return m_objVaxServerSIP.PlayWaveSetVolumeToConferenceRoom(sRoomName, nWaveId, nVolume);
    }

    public bool RecordWaveStartToConferenceRoom(string sRoomName, string sFileName)
    {
        return m_objVaxServerSIP.RecordWaveStartToConferenceRoom(sRoomName, sFileName);
    }
    public bool RecordWaveStopToConferenceRoom(string sRoomName)
    {
        return m_objVaxServerSIP.RecordWaveStopToConferenceRoom(sRoomName);
    }
    public bool RecordWavePauseToConferenceRoom(string sRoomName, bool bEnable)
    {
        return m_objVaxServerSIP.RecordWavePauseToConferenceRoom(sRoomName, bEnable);
    }

    public bool VoiceSessionLost(bool bEnable, int nTimeout)
    {
        return m_objVaxServerSIP.VoiceSessionLost(bEnable, nTimeout);
    }

    public long SendInfoVM(string sUserLogin, int nNewMsgCount, int nOldMsgCount, bool bMsgWaiting)
    {
        return m_objVaxServerSIP.SendInfoVM(sUserLogin, nNewMsgCount, nOldMsgCount, bMsgWaiting);
    }

    public bool StartVaxTeleTick(int nTickId, int nElapse)
    {
        return m_objVaxServerSIP.StartVaxTeleTick(nTickId, nElapse);
    }
    public bool StopVaxTeleTick(int nTickId)
    {
        return m_objVaxServerSIP.StopVaxTeleTick(nTickId);
    }

    public bool SetUserAgentName(string sName)
    {
        return m_objVaxServerSIP.SetUserAgentName(sName);
    }
    public string GetUserAgentName()
    {
        return m_objVaxServerSIP.GetUserAgentName().ToString();
    }

    public bool SetSessionNameSDP(string sName)
    {
        return m_objVaxServerSIP.SetSessionNameSDP(sName);
    }
    public string GetSessionNameSDP()
    {
        return m_objVaxServerSIP.GetSessionNameSDP().ToString();
    }

    public bool SendDTMFCallSession(int nSessionId, int nChannelId, int nTypeDTMF, int nDigit)
    {
        return m_objVaxServerSIP.SendDTMFCallSession(nSessionId, nChannelId, nTypeDTMF, nDigit);
    }

    public bool DetectDigitDTMF(int nSessionId, int nChannelId, int nTypeDTMF, bool bEnable, int nMilliSecondTimeout)
    {
        return m_objVaxServerSIP.DetectDigitDTMF(nSessionId, nChannelId, nTypeDTMF, bEnable, nMilliSecondTimeout);
    }

    public int GetVaxErrorCode()
    {
        return m_objVaxServerSIP.GetVaxErrorCode();
    }

    public bool DialToneToCallSession(bool bEnable, int nSessionId, int nWaveId)
    {
        return m_objVaxServerSIP.DialToneToCallSession(bEnable, nSessionId, nWaveId);
    }

    public bool DiagnosticLogSIP(bool bInbound, bool bOutbound)
    {
        return m_objVaxServerSIP.DiagnosticLogSIP(bInbound, bOutbound);
    }

    public long SplitCallSession(int nSessionId, int nChannelId)
    {
        return m_objVaxServerSIP.SplitCallSession(nSessionId, nChannelId);
    }

    public bool MoveCall(int nSrcSessionId, int nChannelId, int nDscSessionId)
    {
        return m_objVaxServerSIP.MoveCall(nSrcSessionId, nChannelId, nDscSessionId);
    }

    public bool CallSessionSendStatusResponse(int nSessionId, int nStatusCode, string sReasonPhrase, string sContactURI)
    {
        return m_objVaxServerSIP.CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase, sContactURI);
    }

    public bool CallSessionDetectAMD(int nSessionId, int nChannelId, bool bEnable, int nAnalysisTime, int nSilenceTime, int nSilenceCount)
    {
        return m_objVaxServerSIP.CallSessionDetectAMD(nSessionId, nChannelId, bEnable, nAnalysisTime, nSilenceTime, nSilenceCount);
    }

    public bool AddCustomHeader(int nReqId, string sName, string sValue)
    {
        return m_objVaxServerSIP.AddCustomHeader(nReqId, sName, sValue);
    }

    public bool RemoveCustomHeader(int nReqId, string sName)
    {
        return m_objVaxServerSIP.RemoveCustomHeader(nReqId, sName);
    }

    public bool RemoveCustomHeaderAll(int nReqId)
    {
        return m_objVaxServerSIP.RemoveCustomHeaderAll(nReqId);
    }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

    public int GetCallSessionTxCodec(int nSessionId, int nChannelId)
    {
        return m_objVaxServerSIP.GetCallSessionTxCodec(nSessionId, nChannelId);
    }

    public int GetCallSessionRxCodec(int nSessionId, int nChannelId)
    {
        return m_objVaxServerSIP.GetCallSessionRxCodec(nSessionId, nChannelId);
    }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

    public bool BusyLampSubscribeAccept(int nSubScrbId, bool bAuthenticate, int nExpires)
    {
        return m_objVaxServerSIP.BusyLampSubscribeAccept(nSubScrbId, bAuthenticate, nExpires);
    }

    public bool BusyLampSubscribeReject(int nSubScrbId, int nStatusCode, string sReasonPhrase)
    {
        return m_objVaxServerSIP.BusyLampSubscribeReject(nSubScrbId, nStatusCode, sReasonPhrase);
    }

    public bool BusyLampSendStatus(string sFromUserName, string sToUserName, int nStateId)
    {
        return m_objVaxServerSIP.BusyLampSendStatus(sFromUserName, sToUserName, nStateId);
    }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

    public bool SetCallSessionData(int nSessionId, object objCustomData)
    {
        GCHandle hGC = GCHandle.Alloc(objCustomData);
        
        if(!m_objVaxServerSIP.SetCallSessionData(nSessionId, (long) (IntPtr)hGC))
        {
            hGC.Free();
            return false;
        }

        return true;
    }

    public object GetCallSessionData(int nSessionId)
    {
        long lData = m_objVaxServerSIP.GetCallSessionData(nSessionId);
        if(lData == 0) return null;

        GCHandle hGC = (GCHandle)((IntPtr)lData);
        return (hGC.Target as object);
    }

    public void FreeCallSessionData(int nSessionId)
    {
        long lData = m_objVaxServerSIP.GetCallSessionData(nSessionId);
        if(lData == 0) return;

        GCHandle hGC = (GCHandle)((IntPtr)lData);
        hGC.Free();
    }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

    public bool SetUserData(string sUserName, object objCustomData)
    {
        GCHandle hGC = GCHandle.Alloc(objCustomData);
        
        if(!m_objVaxServerSIP.SetUserData(sUserName, (long) (IntPtr)hGC))
        {
            hGC.Free();
            return false;
        }

        return true;
    }

    public object GetUserData(string sUserName)
    {
        long lData = m_objVaxServerSIP.GetUserData(sUserName);
        if(lData == 0) return null;

        GCHandle hGC = (GCHandle)((IntPtr)lData);
        return (hGC.Target as object);
    }

    public void FreeUserData(string sUserName)
    {
        long lData = m_objVaxServerSIP.GetUserData(sUserName);
        if(lData == 0) return;

        GCHandle hGC = (GCHandle)((IntPtr) lData);
        hGC.Free();
    }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

    public bool SetLineData(string sLineName, object objCustomData)
    {
        GCHandle hGC = GCHandle.Alloc(objCustomData);
        
        if(!m_objVaxServerSIP.SetLineData(sLineName, (long) (IntPtr)hGC))
        {
            hGC.Free();
            return false;
        }

        return true;
    }

    public object GetLineData(string sLineName)
    {
        long lData = m_objVaxServerSIP.GetLineData(sLineName);
        if(lData == 0) return null;

        GCHandle hGC = (GCHandle)((IntPtr)lData);
        return (hGC.Target as object);
    }

    public void FreeLineData(string sLineName)
    {
        long lData = m_objVaxServerSIP.GetLineData(sLineName);
        if(lData == 0) return;

        GCHandle hGC = (GCHandle)((IntPtr)lData);
        hGC.Free();
    }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

    public bool SetDirectProxyData(string sProxyName, object objCustomData)
    {
        GCHandle hGC = GCHandle.Alloc(objCustomData);
        
        if(!m_objVaxServerSIP.SetDirectProxyData(sProxyName, (long) (IntPtr)hGC))
        {
            hGC.Free();
            return false;
        }

        return true;
    }
	
    public object GetDirectProxyData(string sProxyName)
    {
        long lData = m_objVaxServerSIP.GetDirectProxyData(sProxyName);
        if(lData == 0) return null;

        GCHandle hGC = (GCHandle)((IntPtr)lData);
        return (hGC.Target as object);
    }

    public void FreeDirectProxyData(string sProxyName)
    {
        long lData = m_objVaxServerSIP.GetDirectProxyData(sProxyName);
        if(lData == 0) return;

        GCHandle hGC = (GCHandle)((IntPtr)lData);
        hGC.Free();
    }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

    public bool SetConferenceRoomData(string sRoomName, object objCustomData)
    {
        GCHandle hGC = GCHandle.Alloc(objCustomData);
        
        if(!m_objVaxServerSIP.SetConferenceRoomData(sRoomName, (long) (IntPtr)hGC))
        {
            hGC.Free();
            return false;
        }

        return true;
    }

    public object GetConferenceRoomData(string sRoomName)
    {
        long lData = m_objVaxServerSIP.GetConferenceRoomData(sRoomName);
        if(lData == 0) return null;

        GCHandle hGC = (GCHandle)((IntPtr)lData);
        return (hGC.Target as object);
    }

    public void FreeConferenceRoomData(string sRoomName)
    {
        long lData = m_objVaxServerSIP.GetConferenceRoomData(sRoomName);
        if(lData == 0) return;

        GCHandle hGC = (GCHandle)((IntPtr)lData);
        hGC.Free();
    }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

    public bool TrvsUserStart()
    {
        String sFile = m_objVaxServerSIP.GetVersionFile();
        
        return m_objVaxServerSIP.TrvsUserStart();
    }

    public string TrvsUserNext()
    {
        return m_objVaxServerSIP.TrvsUserNext();
    }

    public bool TrvsLineStart()
    {
        return m_objVaxServerSIP.TrvsLineStart();
    }

    public string TrvsLineNext()
    {
        return m_objVaxServerSIP.TrvsLineNext();
    }

    public bool TrvsDirectProxyStart()
    {
        return m_objVaxServerSIP.TrvsDirectProxyStart();
    }

    public string TrvsDirectProxyNext()
    {
        return m_objVaxServerSIP.TrvsDirectProxyNext();
    }

    public bool TrvsCallSessionStart()
    {
        return m_objVaxServerSIP.TrvsCallSessionStart();
    }

    public int TrvsCallSessionNext()
    {
        return m_objVaxServerSIP.TrvsCallSessionNext();
    }

    public bool TrvsConferenceRoomStart()
    {
        return m_objVaxServerSIP.TrvsConferenceRoomStart();
    }

    public string TrvsConferenceRoomNext()
    {
        return m_objVaxServerSIP.TrvsConferenceRoomNext();
    }

    ////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////

    public int GetCallCount()
    {
        return m_objVaxServerSIP.GetCallCount();
    }

    public int GetUserCount()
    {
        return m_objVaxServerSIP.GetUserCount();
    }

    public int GetLineCount()
    {
        return m_objVaxServerSIP.GetLineCount();
    }

    public int GetDirectProxyCount()
    {
        return m_objVaxServerSIP.GetDirectProxyCount();
    }

    public int GetCallSessionCount()
    {
        return m_objVaxServerSIP.GetCallSessionCount();
    }

    public int GetConferenceRoomCount()
    {
        return m_objVaxServerSIP.GetConferenceRoomCount();
    }

    /////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////

    public int CustomListOpen(int nTableSize)
    {
        return m_objVaxServerSIP.CustomListOpen(nTableSize);
    }

    public bool CustomListClose(int nListId)
    {
        return m_objVaxServerSIP.CustomListClose(nListId);
    }
	
    public bool CustomListAddData(int nListId, string sKey, object objCustomData)
    {
         GCHandle hGC = GCHandle.Alloc(objCustomData);
        
        if(!m_objVaxServerSIP.CustomListAddData(nListId, sKey, (long) (IntPtr)hGC))
        {
            hGC.Free();
            return false;
        }

        return true;
    }

    public bool CustomListRemoveData(int nListId, string sKey)
    {
        long lData = m_objVaxServerSIP.CustomListFindData(nListId, sKey);
        if(lData == 0) return false;

        GCHandle hGC = (GCHandle)((IntPtr)lData);
        hGC.Free();

        return m_objVaxServerSIP.CustomListRemoveData(nListId, sKey);
    }

    public object CustomListFindData(int nListId, string sKey)
    {
        long lData = m_objVaxServerSIP.CustomListFindData(nListId, sKey);
        if(lData == 0) return null;

        GCHandle hGC = (GCHandle)((IntPtr)lData);
        return (hGC.Target as object);
    }

    public int CustomListCount(int nListId)
    {
        return m_objVaxServerSIP.CustomListCount(nListId);
    }

    public bool CustomListReset(int nListId)
    {
        return m_objVaxServerSIP.CustomListReset(nListId);
    }

    public bool CustomListTrvsStart(int nListId)
    {
        return m_objVaxServerSIP.CustomListTrvsStart(nListId);
    }

    public object CustomListTrvsNext(int nListId)
    {
        long lData = m_objVaxServerSIP.CustomListTrvsNext(nListId);
        if(lData == 0) return null;

        GCHandle hGC = (GCHandle)((IntPtr)lData);
        return (hGC.Target as object);
    }

    public string GetCallSessionHeaderCallId(int nSessionId, int nChannelId)
    {
        return m_objVaxServerSIP.GetCallSessionHeaderCallId(nSessionId, nChannelId);
    }

    public bool CallSessionMuteVoice(int nSessionId, int nChannelId, bool bListen, bool bSpeak)
    {
        return m_objVaxServerSIP.CallSessionMuteVoice(nSessionId, nChannelId, bListen, bSpeak);
    }

    public bool VideoCOMM(bool bEnable)
    {
        return m_objVaxServerSIP.VideoCOMM(bEnable);
    }

        
	/////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////// RingGroup  ////////////////////////////////////////////

	public bool AddRingGroup(string sGroupName)
    {
        return m_objVaxServerSIP.AddRingGroup(sGroupName);
    }

	public void RemoveRingGroup(string sGroupName)
    {
        m_objVaxServerSIP.RemoveRingGroup(sGroupName);
    }

	public bool AddRingGroupAgent(string sGroupName, string sUserName)
    {
        return m_objVaxServerSIP.AddRingGroupAgent(sGroupName, sUserName);
    }

	public void RemoveRingGroupAgent(string sGroupName, string sUserName)
    {
        m_objVaxServerSIP.RemoveRingGroupAgent(sGroupName, sUserName);
    }


	public void SetRingGroupProcessMode(string sGroupName, int nModeId, int nModeType)
    {
        m_objVaxServerSIP.SetRingGroupProcessMode(sGroupName, nModeId, nModeType);
    }

	public bool SetRingGroupAgentPriority(string sGroupName, string sUserName, int nPriority)
    {
        return m_objVaxServerSIP.SetRingGroupAgentPriority(sGroupName, sUserName, nPriority);
    }

    public bool AddCallSessionToRingGroup(string sGroupName, string sCallerName, string sCallFrom, int nSessionId)
    {
        return m_objVaxServerSIP.AddCallSessionToRingGroup(sGroupName, sCallerName, sCallFrom, nSessionId);
    }

    public bool RemoveCallSessionFromRingGroup(int nSessionId)
    {
        return m_objVaxServerSIP.RemoveCallSessionFromRingGroup(nSessionId);
    }

	///////////////////////////////////////////////////////////////////////////////////

    public bool AddCallPickUpGroup(string sGroupName)
    {
        return m_objVaxServerSIP.AddCallPickUpGroup(sGroupName);
    }

    public void RemoveCallPickUpGroup(string sGroupName)
    {
        m_objVaxServerSIP.RemoveCallPickUpGroup(sGroupName);
    }

    public bool AddCallPickUpGroupMember(string sGroupName, string sUserName)
    {
        return m_objVaxServerSIP.AddCallPickUpGroupMember(sGroupName, sUserName);
    }

    public void RemoveCallPickUpGroupMember(string sGroupName, string sUserName)
    {
        m_objVaxServerSIP.RemoveCallPickUpGroupMember(sGroupName, sUserName);
    }
	
    public bool PickUpCall(int nSessionId, string sUserName)
    {
        return m_objVaxServerSIP.PickUpCall(nSessionId, sUserName);
    }
	
    ///////////////////////////////////////////////////////////////////////////////

    public bool ParkCallSession(int nSessionId, int nChannelId, int nSlotId)
    {
        return m_objVaxServerSIP.ParkCallSession(nSessionId, nChannelId, nSlotId);
    }

    public bool ConnectToParkedCallSession(int nSessionId, int nChannelId, int nSlotId)
    {
        return m_objVaxServerSIP.ConnectToParkedCallSession(nSessionId, nChannelId, nSlotId);
    }


	//////////////////////////////////////////////////////////////////////////////

	public bool AddQueue(string sQueueName)
    {
        return m_objVaxServerSIP.AddQueue(sQueueName);
    }

	public void RemoveQueue(string sQueueName)
    {
        m_objVaxServerSIP.RemoveQueue(sQueueName);
    }
        
	public bool AddQueueAgent(string sQueueName, string sUserName)
    {
        return m_objVaxServerSIP.AddQueueAgent(sQueueName, sUserName);
    }

    public void RemoveQueueAgent(string sQueueName, string sUserName)
    {
        m_objVaxServerSIP.RemoveQueueAgent(sQueueName, sUserName);
    }

    public void SetQueueAgentPriority(string sQueueName, string sUserName, int nPriority)
    {
        m_objVaxServerSIP.SetQueueAgentPriority(sQueueName, sUserName, nPriority);
    }

    public bool SetQueueAgentStatus(string sQueueName, string sAgentName, int nStatusId)
    {
       return m_objVaxServerSIP.SetQueueAgentStatus(sQueueName, sAgentName, nStatusId);
    }

	public void SetQueueProcessMode(string sQueueName, int nModeId, int nModeType)
    {
        m_objVaxServerSIP.SetQueueProcessMode(sQueueName, nModeId, nModeType);
    }
    	
	public bool AddCallSessionToQueue(string sQueueName, string sCallerName, string sCallerId, int nSessionId, int nTimeout)
    {
        return m_objVaxServerSIP.AddCallSessionToQueue(sQueueName, sCallerName, sCallerId, nSessionId, nTimeout);
    }
    
	//////////////////////////////////////////////////////////////////////////////

    public bool AddStealthListener(int nStealthSessionId, int nCapturePeerType, string sCapturePeerName, int nVoiceTypeId)
    {
        return m_objVaxServerSIP.AddStealthListener(nStealthSessionId, nCapturePeerType, sCapturePeerName, nVoiceTypeId);
    }
        	
    public bool SetExtDataREC(int nSessionId, int nChannelId, string sExtData)
    {
        return m_objVaxServerSIP.SetExtDataREC(nSessionId, nChannelId, sExtData);
    }

    public bool ConnectToServerREC(int nSessionId, int nChannelId, string sCallerName, string sCallerId, string sDialNo, int nToPeerType, string sToPeerName, int nTimeout)
    {
        return m_objVaxServerSIP.ConnectToServerREC(nSessionId, nChannelId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout);
    }

    public bool AdjustCallSessionVoiceType(int nSessionId, int nChannelId, int nVoiceTypeId)
    {
        return m_objVaxServerSIP.AdjustCallSessionVoiceType(nSessionId, nChannelId, nVoiceTypeId);
    }

    public bool AddNetworkRouteSIP(string sAssignedIP, string sRouterIP)
    {
        return m_objVaxServerSIP.AddNetworkRouteSIP(sAssignedIP, sRouterIP);
    }

    public bool AddNetworkRouteRTP(string sAssignedIP, string sRouterIP)
    {
        return m_objVaxServerSIP.AddNetworkRouteRTP(sAssignedIP, sRouterIP);
    }

    public int SendNotifyMsgSIP(string sMsgFrom, string sMsgTo, int nToPeerType, string sToPeerName)
    {
        return m_objVaxServerSIP.SendNotifyMsgSIP(sMsgFrom, sMsgTo, nToPeerType, sToPeerName);
    }
        
    #endregion


    #region Events

    public virtual void OnLineRegisterTrying(string sLineName)
    {
    }
    public virtual void OnLineRegisterFailed(string sLineName, int nStatusCode, string sReasonPhrase)
    {
    }
    public virtual void OnLineRegisterSuccess(string sLineName)
    {
    }
    public virtual void OnLineUnRegisterTrying(string sLineName)
    {
    }
    public virtual void OnLineUnRegisterFailed(string sLineName, int nStatusCode, string sReasonPhrase)
    {
    }
    public virtual void OnLineUnRegisterSuccess(string sLineName)
    {
    }

    public virtual void OnUnRegisterUser(string sUserLogin)
    {
    }
    public virtual void OnRegisterUser(string sUserLogin, string sDomain, string sUserAgentName, string sFromIP, int nFromPort, int nRegId)
    {
           
    }
    public virtual void OnRegisterUserSuccess(string sUserLogin, string sFromIP, int nFromPort, int nRegId)
    {
    }
    public virtual void OnRegisterUserFailed(string sUserLogin, string sFromIP, int nFromPort, int nRegId)
    {
    }

    public virtual void OnChatMessageText(int nChatMsgId, string sMsgFrom, string sMsgTo, string sMsgText, int nFromPeerType, string sFromPeerName, string sFromIP, int nFromPort)
    {
    }
    public virtual void OnChatMessageTyping(int nChatMsgId, string sMsgFrom, string sMsgTo, bool bIsTypingStart, int nFromPeerType, string sFromPeerName, string sFromIP, int nFromPort)
    {
    }
    public virtual void OnChatStatusSubscribe(int nSubscrbId, string sMsgFrom, string sMsgTo, int nFromPeerType, string sFromPeerName, string sFromIP, int nFromPort)
    {
    }
    
    public virtual void  OnChatStatusSendSubscribeSuccess(int SubscrbId)
    {
 	
    }     
    
    public virtual void  OnChatStatusSendSubscribeFailed(int SubscrbId, int StatusCode, string sReasonPhrase)
    {
 	
    }
    
    public virtual void OnChatMessageSuccess(int nChatMsgId)
    {
    }
    public virtual void OnChatMessageFailed(int nChatMsgId, int nStatusCode, string sReasonPhrase)
    {
    }
    public virtual void OnChatMessageTimeout(int nChatMsgId)
    {
    }

    public virtual void OnIncomingCall(int nSessionId, string sCallerName, string sCallerId, string sDialNo, int nFromPeerType, string sFromPeerName, string sUserAgentName, string sFromIP, int nFromPort)
    {
    }

    public virtual void OnCallSessionConnecting(int nSessionId, int nChannelId, int nStatusCode, string sReasonPhrase)
    {
    }
    public virtual void OnCallSessionFailed(int nSessionId, int nChannelId, int nStatusCode, string sReasonPhrase)
    {
    }
    public virtual void OnCallSessionConnected(int nSessionId)
    {
    }
    public virtual void OnCallSessionClosed(int nSessionId, int nChannelId, int nReasonCode)
    {
    }

    public virtual void OnCallSessionLost(int nSessionId, int nChannelId)
    {
    }

    public virtual void OnCallSessionHangup(int nSessionId, int nChannelId)
    {
    }

    public virtual void OnCallSessionTimeout(int nSessionId, int nChannelId)
    {
    }

    public virtual void OnCallSessionCancelled(int nSessionId)
    {
    }

    public virtual void OnCallSessionOnHold(int nSessionId, int nChannelId)
    {
    }
    public virtual void OnCallSessionOffHold(int nSessionId, int nChannelId)
    {
    }

    ////////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////////

    public virtual void OnCallSessionTransferBlind(int nTransfererSessionId, int nTransfererChannelId, string sTransferer, string sTransferee, string sTransferTo)
    {
    }
    public virtual void OnCallSessionTransferConsult(int nTransfererSessionId,  int nTransfererChannelId, int nTransferToSessionId, int nTransferToChannelId, string sTransferer, string sTransferee, string sTransferTo)
    {
    }

    public virtual void OnCallSessionTransfering(int nSessionId, int nTransferType, int nChannelId, int nStatusCode, string sReasonPhrase)
    {
    }

    public virtual void OnCallSessionTransferFailed(int nSessionId, int nTransferType, int nChannelId, int nStatusCode, string sReasonPhrase)
    {
    }

    public virtual void OnCallSessionTransferTimeout(int nSessionId, int nTransferType, int nChannelId)
    {
    }

    public virtual void OnCallSessionTransfered(int nSessionId, int nTransferType)
    {
    }

    ////////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////////

    public virtual void OnDetectedDigitDTMF(int nSessionId, int nChannelId, string sDigitDTMF)
    {
    }

    public virtual void OnOutgoingDiagnosticLog(string sMsgSIP, string sToIP, int nToPort)
    {
    }
    public virtual void OnIncomingDiagnosticLog(string sMsgSIP, string sFromIP, int nFromPort)
    {
    }

    public virtual void OnVaxTeleTick(int nTickId)
    {
    }

    public virtual void OnSendTimeoutVM(int nMsgIdVM)
    {
    }
    public virtual void OnSendSuccessVM(int nMsgIdVM)
    {
    }

    public virtual void OnCallSessionDialToneStart(int nSessionId, int nChannelId, int nWaveId)
    {
    }
    public virtual void OnCallSessionDialToneStop(int nSessionId, int nChannelId, int nWaveId)
    {
    }

    public virtual void OnCallSessionPlayWaveDone(int nSessionId, int nChannelId, int nWaveId)
    {
    }

    public virtual void OnConferenceRoomPlayWaveDone(string sRoomName, int nWaveId)
    {
    }

    public virtual void OnCallSessionCreated(int nSessionId, int nReasonCode)
    {

    }
        
    public virtual void OnCallSessionDetectedAMD(int nSessionId, int nChannelId, bool bIsHuman)
    {

    }

    public void OnCallSessionRecordedPCM(int nSessionId, int nChannelId, long lDataPCM, int nSizePCM, int nTypePCM)
    {
        Byte[] aDataPCM = new byte[nSizePCM];
        Marshal.Copy(new IntPtr(lDataPCM), aDataPCM, 0, nSizePCM);

        OnCallSessionRecordedPCM(nSessionId, aDataPCM, nSizePCM);
    }

    public virtual void OnCallSessionRecordedPCM(int nSessionId, Byte[] aDataPCM, int nSizePCM)
    {
        
    }

    public void OnConferenceRoomRecordedPCM(string sRoomName, long lDataPCM, int nSizePCM, int nTypePCM)
    {
        Byte[] aDataPCM = new byte[nSizePCM];
        Marshal.Copy(new IntPtr(lDataPCM), aDataPCM, 0, nSizePCM);

        OnConferenceRoomRecordedPCM(sRoomName, aDataPCM, nSizePCM);
    }

    public virtual void OnConferenceRoomRecordedPCM(string sRoomName, Byte[] aDataPCM, int nSizePCM)
    {
    }

    public virtual void OnBusyLampSubscribe(int nSubScrbId, string sUserName, string sToUserName, string sFromIP, int nFromPort)
    {
    }

    public virtual void OnBusyLampSendStatus(string sFromUserName, string sToUserName, int nStateId)
    {
    }

    public virtual void OnBusyLampUnSubscribe(int nSubScrbId, string sUserName, string sToUserName, string sFromIP, int nFromPort)
    {
    }

    public virtual void OnBusyLampSubscribeSuccess(int nSubScrbId, string sUserName)
    {
    }

    public virtual void OnBusyLampSubscribeFailed(int nSubScrbId, string sUserName)
    {
    }



    public virtual void OnVaxErrorLog(string sFuncName, int nErrorCode, string sErrorMsg)
    {

    }


    public virtual void OnAddCallSessionToQueueSuccess(string sQueueName, int nSessionId)
    {
    }

    public virtual void OnAddCallSessionToQueueFailed(string sQueueName, int nSessionId)
    {
    }

    public virtual void OnQueuePlayWaveStart(int nEventType, string sQueueName, int nSessionId)
    {
    }

    public virtual void OnQueuePlayWaveStop(int nEventType, string sQueueName, int nSessionId)
    {
    } 

    public virtual void OnAddCallSessionToRingGroupSuccess(string sGroupName, int nSessionId)
    {
    }

    public virtual void OnAddCallSessionToRingGroupFailed(string sGroupName, int nSessionId)
    {
    }

    public virtual void OnVaxLicenseChannel(int nTotalChannels, int nUsedChannels)
    {

    }

        
    public virtual void OnSendReqTransferCallTimeout(int nSessionId, int nChannelId)
    {

    }
        
    public virtual void OnSendReqTransferCallAccepted(int nSessionId, int nChannelId)
    {

    }

    public virtual void OnSendReqTransferCallFailed(int nSessionId, int nChannelId, int nStatusCode, string sReasonPhrase)
    {

    }

    public virtual void OnQualityReportPUBLISH(string sMsgSIP, string sMsgSDP, string sFromIP, int nFromPort)
    {

    }


    public virtual void OnServerConnectingREC(int nSessionId, int nChannelId, int nStatusCode, string sReasonPhrase)
    {
    }

    public virtual void OnServerConnectedREC(int nSessionId, int nChannelId)
    {
    }

    public virtual void OnServerFailedREC(int nSessionId, int nChannelId, int nStatusCode, string sReasonPhrase)
    {
    }

    public virtual void OnServerTimeoutREC(int nSessionId, int nChannelId)
    {
    }

    public virtual void OnServerHungupREC(int nSessionId, int nChannelId)
    {
    }
    
    public virtual void  OnQueueAgentConnectStarted(string sQueueName, string sAgentName, int nSessionId)
    {
 	
    }    
    
    public virtual void  OnQueueAgentConnectTrying(string sQueueName, string sAgentName, int nSessionId, int StatusCode, string sReasonPhrase)
    {
 	
    }    
    
    public virtual void  OnQueueAgentConnectFailed(string sQueueName, string sAgentName, int nSessionId, int StatusCode, string sReasonPhrase)
    {
 	
    }    
    
    public virtual void  OnQueueAgentConnectTimeout(string sQueueName, string sAgentName, int nSessionId)
    {
 	
    }    

    public virtual void  OnQueueAgentConnectSuccess(string sQueueName, string sAgentName, int nSessionId)
    {
 	
    }

    public virtual void OnSendNotifyMsgSuccess(int nMsgId)
    {

    }

    public virtual void OnSendNotifyMsgFailed(int nMsgId, int nStatusCode, string sReasonPhrase)
    {

    }

    #endregion

    }

