using System;
using System.Collections.Generic;
using System.Text;

class cCodec
{
    public const string G711U_TEXT = "G711u-Law";
    public const string G711A_TEXT = "G711a-Law";
    public const string ILBC_TEXT = "iLBC";
    public const string G610_TEXT = "GSM6.10";
    public const string G729_TEXT = "G729";

    private const int VAX_CODEC_GSM610 = 0;
    private const int VAX_CODEC_ILBC = 1;
    private const int VAX_CODEC_G711A = 2;
    private const int VAX_CODEC_G711U = 3;
    private const int VAX_CODEC_G729 = 4;

    public const int TOTAL_SIZE_CODEC = 5;

    public string GetCodecNo(string sCodecName)
    {
        string[] objCodeList = new string[5] { G610_TEXT, ILBC_TEXT, G711A_TEXT, G711U_TEXT, G729_TEXT };

        int nCodeNo = Array.IndexOf(objCodeList, sCodecName);

        string sCodecNo = "";

        if(nCodeNo != -1)
            sCodecNo = Convert.ToString(nCodeNo);

        return sCodecNo;
    }

    public string GetCodecName(string sCodecNo)
    {
        string sCodecName = "";

        int nCodecNo = Convert.ToInt32(sCodecNo);

        switch (nCodecNo)
        {
            case VAX_CODEC_G711U:
                sCodecName = G711U_TEXT;
                break;

            case VAX_CODEC_G711A:
                sCodecName = G711A_TEXT;
                break;

            case VAX_CODEC_ILBC:
                sCodecName = ILBC_TEXT;
                break;

            case VAX_CODEC_GSM610:
                sCodecName = G610_TEXT;
                break;

            case VAX_CODEC_G729:
                sCodecName = G729_TEXT;
                break;
        }

        return sCodecName;
    }

}
