unit AddConfsDlg;

interface

uses
  Winapi.Windows,
  Winapi.Messages,
  System.SysUtils,
  System.StrUtils,
  System.Variants,
  System.Classes,
  Vcl.Graphics,
  Vcl.Controls,
  Vcl.Forms,
  Vcl.Dialogs,
  Vcl.StdCtrls,

  VaxTeleServerSIP, Vcl.ExtCtrls;

type TAddConfsForm = class(TForm)
    EditRoomNo: TEdit;
    btnAddRoom: TButton;
    btnRemoveRoom: TButton;
    Label1: TLabel;
    Label2: TLabel;
    LabelRoomNote: TLabel;
    ComboRoomName: TComboBox;
    GroupBox1: TGroupBox;

    procedure AddRoom_Click(Sender: TObject);
    procedure RemoveConf_Click(Sender: TObject);

    function AddRoomChecks() : Boolean;
    procedure ComboRoomName_SelectedIndexChanged(Sender: TObject);

    public
    constructor Create(AOwner : TComponent; var pVaxTeleSIP : TVaxTeleServerSIP); reintroduce; overload;


  end;

var
  AddConfsForm: TAddConfsForm;
   m_pVaxTeleSIP : TVaxTeleServerSIP;
implementation

{$R *.dfm}

procedure TAddConfsForm.ComboRoomName_SelectedIndexChanged(Sender: TObject);
var sRoomName, sRoomNo : string;
bResult : Boolean;
begin

    sRoomNo := '';
    sRoomName := Trim(ComboRoomName.Text);

    bResult := m_pVaxTeleSIP.GetRoomDetails(sRoomName, sRoomNo);
    if Not bResult then
        Exit;

    EditRoomNo.Text := sRoomNo;

end;

constructor TAddConfsForm.Create(AOwner : TComponent; var pVaxTeleSIP : TVaxTeleServerSIP);
    begin
        inherited Create(AOwner);
        m_pVaxTeleSIP := pVaxTeleSIP;
    end;

function TAddConfsForm.AddRoomChecks() : Boolean;
var
  sDigits: string;
  sRoomName: string;
  nCount: Integer;
  nIndex: Integer;
  sRoomNo: string;
begin

    if Length(Trim(ComboRoomName.Text)) <= 0 then
    begin
        ShowMessage('RoomName can not be empty.');
        Exit(FALSE);
    end;

    if Length(Trim(EditRoomNo.Text)) <= 0 then
    begin
        ShowMessage('RoomNo can not be empty.');
        Exit(FALSE);
    end;


    // check if the room name consists of numbers only

    sDigits := '0123456789';
    sRoomName := ComboRoomName.Text;
    sRoomNo := EditRoomNo.Text;
    nCount := 0;

    for nIndex := 0 to Length(sRoomNo) do
    begin

        if( AnsiPos(sRoomNo[nIndex + 1], sDigits) = 0) then
        begin
            ShowMessage('Login should contain only numerals 0 through 9. For example: 12, 324323, 800122, 2109756 etc.');
            Result := false;
            exit;
        end;

        nCount := nCount + 1;

        if(nCount >= Length(sRoomNo)) then
        begin
            Result := true;
            break;
        end;
    end;

    Result := True;
end;

procedure TAddConfsForm.AddRoom_Click(Sender: TObject);
var bResult : Boolean;
begin

    if Not AddRoomChecks() then
        Exit;

    bResult := m_pVaxTeleSIP.AddRoom(Trim(ComboRoomName.Text), Trim(EditRoomNo.Text));
    If Not bResult then
        ShowMessage('Room could not be added.');

    ComboRoomName.Items.Add(Trim(ComboRoomName.Text));
    ShowMessage('Room added successfully.');
end;

procedure TAddConfsForm.RemoveConf_Click(Sender: TObject);
var sRoomName : string;
begin
    sRoomName := ComboRoomName.Text;
    m_pVaxTeleSIP.RemoveRoom(sRoomName);
    ShowMessage('Room Removed.');
end;

end.
