﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cStoreUser : cStoreRegistry
    {
        const string USER_ROOT_PATH = "Users\\";

        public cStoreUser()
        {
        }

        ~cStoreUser()
        {
        }

        /////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////

        public bool AddUser(string sUserName, string sPassword, string sCodecList, bool bBlocked)
        {
            if (sUserName.Length == 0)
                return false;

            string sKeyPath = USER_ROOT_PATH + sUserName;

            base.SetTEXT(sKeyPath, "UserName", sUserName);
            base.SetTEXT(sKeyPath, "Password", sPassword);
            base.SetTEXT(sKeyPath, "CodecList", sCodecList);

            base.SetBOOL(sKeyPath, "Blocked", bBlocked);
            return true;
        }

        public bool GetUser(string sUserName, ref string sPassword, ref string sCodecList, ref bool bBlocked)
        {
            if (sUserName.Length == 0)
                return false;

            string sKeyPath = USER_ROOT_PATH + sUserName;

            base.GetTEXT(sKeyPath, "UserName", ref sUserName);
            base.GetTEXT(sKeyPath, "Password", ref sPassword);
            base.GetTEXT(sKeyPath, "CodecList", ref sCodecList);

            base.GetBOOL(sKeyPath, "Blocked", ref bBlocked);
            return true;
        }

        public void RemoveUser(string sUserName)
        {
            if (sUserName.Length == 0)
                return;

            string sKeyPath = USER_ROOT_PATH + sUserName;
            base.DeleteSubKey(sKeyPath);          
        }

        public Boolean GetUserNameAll(ref List<string> objLoginList)
        {
            string sKeyPath = USER_ROOT_PATH;
            return base.EnumSubKeys(sKeyPath, ref objLoginList);
        }

        /////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////

        public bool AddUserRoute(string sUserName, string sUserPrefix, string sDialPrefix, int nToPeerType, string sToPeerName)
        {
            if (sUserName.Length == 0)
                return false;

            string sKeyPath = USER_ROOT_PATH + sUserName;

            SetTEXT(sKeyPath, "UserPrefix", sUserPrefix);
            SetTEXT(sKeyPath, "DialPrefix", sDialPrefix);
            SetTEXT(sKeyPath, "ToPeerName", sToPeerName);

            SetINT(sKeyPath, "ToPeerType", nToPeerType);
            return true;
        }

        public bool GetUserRoute(string sUserName, ref string sUserPrefix, ref string sDialPrefix, ref int nToPeerType, ref string sToPeerName)
        {
            if (sUserName.Length == 0)
                return false;

            string sKeyPath = USER_ROOT_PATH + sUserName;

            GetTEXT(sKeyPath, "UserPrefix", ref sUserPrefix);
            GetTEXT(sKeyPath, "DialPrefix", ref sDialPrefix);
            GetTEXT(sKeyPath, "ToPeerName", ref sToPeerName);

            GetINT(sKeyPath, "ToPeerType", ref nToPeerType);
            return true;
        }

        public bool RemoveUserRoute(string sUserName)
        {
            if (sUserName.Length == 0)
                return false;

            string sKeyPath = USER_ROOT_PATH + sUserName;

            base.DeleteValue(sKeyPath, "UserPrefix");
            base.DeleteValue(sKeyPath, "DialPrefix");

            base.DeleteValue(sKeyPath, "ToPeerName");
            base.DeleteValue(sKeyPath, "ToPeerType");

            return true;
        }

        public bool IsDataStored()
        {
            return base.IsKeyExist(USER_ROOT_PATH);
        }
    }
}
